<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Admin as AdminModel;
use app\admin\model\AdminRole;
use think\Db;
use app\admin\model\Menu;
use app\admin\model\Category;

class Admin extends Base
{
    // 管理员中心 - 列表
    public function index()
    {
        $list = AdminModel::all(function ($query) {
            $query->order('id asc');
        });
        foreach ($list as $k => $v) {
            $role_name = Db::name('admin_role')->where('id', $v['role_id'])->value('name');
            $list[$k]['role_name'] = $role_name;
        }
        $this->assign('list', $list);
        return $this->fetch();
    }

    // 管理员中心 - 新增
    public function add()
    {
        if (input('sub')) {
            $data = request()->post();
            $admin_model = new AdminModel;
            $res = $admin_model->insertAdmin($data);
            $res['status'] == 1 ? $this->success($res['msg'], 'index') : $this->error($res['msg']);
        }

        $list = AdminRole::all();
        $this->assign('list', $list);

        return $this->fetch();
    }

    // 管理员中心 - 编辑
    public function edit($id)
    {
        if (input('sub')) {
            $data = request()->post();
            $admin_model = new AdminModel;
            $res = $admin_model->updateAdmin($data, $id);
            $res['status'] == 1 ? $this->success($res['msg'], 'index') : $this->error($res['msg']);
        }

        $res  = AdminModel::get($id);
        $list = AdminRole::all();
        $this->assign('res', $res);
        $this->assign('list', $list);

        return $this->fetch();
    }

    // 管理员中心 - 删除
    public function adminDel($id)
    {
        $res = AdminModel::destroy(['id' => ['in', $id]]);
        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    // 管理员中心 - 我的信息
    public function info()
    {
        $res = AdminModel::get(session('admin.id'));
        $this->assign('res', $res);

        if (input('sub')) {
            $data = request()->post();
            $data['role_id'] = $res['role_id'];
            $admin_model = new AdminModel;
            $res = $admin_model->updateAdmin($data, session('admin.id'));
            $res['status'] == 1 ? $this->success($res['msg'], 'info') : $this->error($res['msg']);
        }

        return $this->fetch();
    }

    // 管理员中心 - 角色管理
    public function role()
    {
        $admin_role_model = AdminRole::all();
        $this->assign('role', $admin_role_model);
        return $this->fetch();
    }

    // 管理员中心 - 删除角色
    public function roleDel($id)
    {
        $admin_role_model = new AdminRole();
        $res  = $admin_role_model->delRole($id);
        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    // 管理员中心 - 添加角色
    public function roleAdd()
    {
        if (input('sub')) {
            $admin_role_model = new AdminRole();
            $param = request()->param();
            $param['insert_time'] = $param['update_time'] = date('Y-m-d H:i:s');
            $res = $admin_role_model->allowField(true)->save($param);
            if ($res) {
                $this->success(OK, 'role');
            } else {
                $this->error(FAIL);
            }
        }
        return $this->fetch();
    }

    // 管理员中心 - 编辑角色
    public function roleEdit($id)
    {
        if (input('sub')) {
            $admin_role_model = new AdminRole();
            $param = request()->param();
            $param['update_time'] = date('Y-m-d H:i:s');
            $res = $admin_role_model->allowField(true)->save($param, ['id' => $id]);
            if ($res) {
                $this->success(OK, 'role');
            } else {
                $this->error(FAIL);
            }
        }

        $res = AdminRole::get($id);
        $this->assign('res', $res);

        return $this->fetch();
    }

    // 管理员中心 - 修改角色状态
    public function roleStatus($id)
    {
        $admin_role_model = new AdminRole();
        $status = $admin_role_model->findStatus($id);

        $status = $status == 1 ? 2 : 1 ;
        $res = $admin_role_model->save(['status'=>$status], ['id'=>$id]);

        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    //  管理员中心 - 栏目权限（前台菜单操作权限）
    public function rolePower1($id)
    {
        $category_model = new Category();
        $role_model     = new AdminRole();
        $column = $category_model->getAllCategory();
        if ($column) {
            foreach ($column as $k => $v) {
                $cate[] = [
                    'name'  => $v['title'],
                    'id'    => $v['id'],
                    'pid'   => $v['pid'],
                    'tag'   => $v['tag'],
                    'mid'   => $v['mid'],
                    'nav'   => $v['nav'],
                    'rank'  => $v['rank'],
                    'status'    => $v['status'],
                    'is_cover'  => $v['is_cover'],
                ];
            }
        } else {
            $cate = [];
        }
        
        $act    = $role_model->findRole($id);
        $nav    = $act['column_list'];
        $navs   = explode(',', $nav);
        $array  = $this->getTree($cate, 0, $navs);
        $arr[]  = [
            "name"  => "所有权限",
            "open"  => true,
            "ico"   => 'iconfont icon-suo',
            "cascade"   => true,
            "checked"   => false,
            'children'  => $array,
        ];
        $this->assign('role', $id);
        $this->assign('arr', $arr);
        return $this->fetch();
    }

    // 管理员中心 - 修改栏目权限
    public function rolePower1Edit()
    {
        $param  = request()->param();
        $nav    = implode(',', $param['nav_list']);     // 菜单id

        $admin_role_model = new AdminRole();
        $res =  $admin_role_model->save(['column_list' => $nav], ['id' => $param['role_id']]);

        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    // 管理员中心 - 后台菜单权限
    public function rolePower2($id)
    {
        $cate = Menu::all(function ($query) {
            $query->order('rank asc, id asc');
        })->toArray();
        $admin_role_model = new AdminRole();
        $act = $admin_role_model->findRole($id);
        $nav = $act['nav_list'];
        $navs = explode(',', $nav);
        $array = $this->getTree($cate, 0, $navs);
        $arr[] = [
            "name"  => "所有权限",
            "open"  => true,
            "ico"   => 'iconfont icon-suo',
            "cascade" => true,
            "checked" => false,
            'children' => $array,
        ];
        $this->assign('role', $id);
        $this->assign('arr',  $arr);
        return $this->fetch();
    }

    // 管理员中心 - 修改后台菜单权限
    public function rolePower2Edit()
    {
        $param  = request()->param();
        $nav    = implode(',', $param['nav_list']);     // 栏目id

        $admin_role_model = new AdminRole();
        $res = $admin_role_model->save(['nav_list' => $nav], ['id' => $param['role_id']]);

        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    public function error_html()
    {
        return $this->fetch();
    }

    ///数据的递归找所有下级（分层次，子集放在children中）
    public function getTree($arr, $pid, $nav)
    {
        $array = [];
        foreach ($arr as $key => &$val) {
            if ($val['pid'] == $pid) {
                if (in_array($val['id'], $nav)) {
                    $val['checked'] = true;
                } else {
                    $val['checked'] = false;
                }
                $val['children'] = self::getTree($arr, $val['id'], $nav);
                $array[] = $val;
            }
        }
        return $array;
    }
}
