<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Category as CategoryModel;
use app\admin\model\DiyModel;
use app\admin\model\AdminRole as role;
use think\Loader;

class Category extends Base
{
    // 栏目管理 - 首页
    public function index()
    {
        $category_model = new CategoryModel;
        $list = $category_model->getAll()->toArray();
        $list = rule($list);
        $admin_role = session('admin.role');
        if ($admin_role !=1){
            $role = new role();
            $roles = $role->findRole($admin_role);
            $column = $roles['column_list'];
            $column = explode(',',$column);
            foreach ($list as $k => $v){
                if (in_array($list[$k]['id'],$column)){
                    $list[$k]['style'] = 1;
                }else{
                    $list[$k]['style'] = 2;
                }
                $list[$k]['num'] = Loader::model('Content')->where('cid', $v['id'])->count();
            }
        }else{
            foreach ($list as $k => $v){
                $list[$k]['style'] = 1;
                $list[$k]['num'] = Loader::model('Content')->where('cid', $v['id'])->count();
            }
        }
        $this->assign('list', $list);
        return $this->fetch();
    }

    // 栏目管理 - 添加
    public function add()
    {
        if (input('sub')) {
            $data = request()->post();

            $category_model = new CategoryModel();
            $res = $category_model->insertCategory($data);

            if ($res['status'] == 1) {
                $this->success(OK, 'index');
            } else {
                $this->error($res['msg']);
            }
        }

        $cat = CategoryModel::all(function ($e) {
            $e->field('id, pid, title')->order('rank asc');
        });
        $cat = action('Menu/rule', ['cate'=>$cat]);
        $this->assign('cat', $cat);
 
        // 模型
        $model = DiyModel::all(function ($e) {
            $e->order('rank asc');
        });
        $this->assign('model', $model);

        // 模板
        $dir_path = './template/default/';
        $this->assign('tpl_cover', get_file_list($dir_path, 'cover_*'));
        $this->assign('tpl_list',  get_file_list($dir_path, 'list_*'));
        $this->assign('tpl_detail',get_file_list($dir_path, 'detail_*'));
        
        return  $this->fetch();
    }

    // 栏目管理 - 编辑
    public function edit($id)
    {
        if (input('sub')) {	
            if (input('type') == 'tag' || input('type') == 'rank') {		// sub, id, type, value
                if (input('type') == 'tag') {
                    if (!preg_match("/^[0-9A-Za-z_]+$/", input('value'))) {
                        return ['status'=>-1, 'msg'=>'分类名称只能由数字，英文字母，下划线组成'];
                    }
                }
				$res = CategoryModel::where('id', $id)->update([input('type')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
			} else {
				$data = request()->post();
                $category_model = new CategoryModel();
                $res = $category_model->updateCategory($data, $id);
                if ($res['status'] == 1) {
                    $this->success(OK, 'index');
                } else {
                    $this->error($res['msg']);
                }
			}
		}

        $res = CategoryModel::get($id);
        $this->assign('res', $res);
        
        $cat = CategoryModel::all(function ($e) {
            $e->field('id, pid, title')->order('rank asc');
        });
        $cat = action('Menu/rule', ['cate'=>$cat]);
        $this->assign('cat', $cat);
 
        $model = DiyModel::all(function ($e) {
            $e->order('rank asc');
        });
        $this->assign('model', $model);

        $dir_path = './template/default/';
        
        $this->assign('tpl_cover', get_file_list($dir_path, 'cover_*'));
        $this->assign('tpl_list',  get_file_list($dir_path, 'list_*'));
        $this->assign('tpl_detail',get_file_list($dir_path, 'detail_*'));
        
        return  $this->fetch();
    }

    // 栏目管理 - 删除
    public function del($id)
    {
        $res = CategoryModel::where('id', 'in', $id)->delete();
		return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
    }

    // 栏目管理 - 批量操作 type 1批量新增 2批量设置模板 3批量SEO设置
    public function batch($type)
    {
        switch ($type) {
            case 1:

                if (input('sub')) {
                    $data = request()->post();

                    $category_model = new CategoryModel();
                    $res = $category_model->insertAllCategory($data);
        
                    if ($res['status'] == 1) {
                        $this->success(OK, 'index');
                    } else {
                        $this->error(FAIL, $res['msg']);
                    }
                }

                $cat = CategoryModel::all(function ($e) {
                    $e->field('id, pid, title')->order('rank asc');
                });
                $cat = action('Menu/rule', ['cate'=>$cat]);
                $this->assign('cat', $cat);
        
                $model = DiyModel::all(function ($e) {
                    $e->order('rank asc');
                });
                $this->assign('model', $model);
        
                $dir_path = './template/default/';
                $this->assign('tpl_cover', get_file_list($dir_path, 'cover_*'));
                $this->assign('tpl_list',  get_file_list($dir_path, 'list_*'));
                $this->assign('tpl_detail',get_file_list($dir_path, 'detail_*'));

                return $this->fetch();
                break;

            case 2:
                $post = request()->post();
                $ids = $post['id'];
                if (count($ids) == 0) {
                    return ['status'=>-s, 'msg'=>'请选择栏目'];
                }
                $data = [
                    'tpl_cover' => $post['tpl_cover'],
                    'tpl_list'  => $post['tpl_list'],
                    'tpl_detail'=> $post['tpl_detail'],
                ];
                $res = CategoryModel::where('id', 'in', $ids)->update($data);
                return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
                break;
            
            case 3:
                $post = request()->post();
                $ids = $post['id'];
                if (count($ids) == 0) {
                    return ['status'=>-s, 'msg'=>'请选择栏目'];
                }
                $data = [
                    'seo_title'     => $post['seo_title'],
                    'seo_keywords'  => $post['seo_keywords'],
                    'seo_describe'  => $post['seo_describe'],
                ];
                $res = CategoryModel::where('id', 'in', $ids)->update($data);

                return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
                break;

            default:
                $this->error();
                break;
        }
    }

    // 栏目管理 - ajax 获取封面模板，列表模板，内容也模板
    public function ajax_getmodel()
    {
        $dir_path = './template/default/';
        $data = [
            'tpl_cover' => get_file_list($dir_path, 'cover_*'),
            'tpl_list'  => get_file_list($dir_path, 'list_*'),
            'tpl_detail'=> get_file_list($dir_path, 'detail_*')
        ];
        return $data;
    }
}