<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | DREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Config as ConfigModel;
use app\admin\model\Link;
use app\admin\model\Banner;
use app\admin\model\Category;
use app\admin\model\Content;
use think\Db;

class Config extends Base
{
	// seo设置
	public function seo()
	{
		if (input('sub')) {
			$data = request()->post();
			foreach ($data as $key => $val) {
				ConfigModel::where('tag', $key)->update(['val' => $val]);
			}
			$this->success(OK, 'seo');
		}
		$list = ConfigModel::all(['type' => 1]);
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 基础设置
	public function basic()
	{
		if (input('sub')) {
			$data = request()->post();
			$config = Db::name('config')->select();
			$arr = [];
			foreach ($config as $k => $v) {
				foreach ($data as $key => $val) {
					if ($key == $config[$k]['tag']) {
						$arr[] = [
							$key => $val
						];
					}
				}
			}
			$array = [];
			foreach ($arr as $ks => $vs) {
				foreach ($vs as $kes => $vas) {
					$array[$kes] = $vas;
				}
			}
			Db::name('config')->startTrans();
			try {
				foreach ($array as $k1 => $v1) {
					Db::name('config')->where(['tag' => $k1])->update(['val' => $v1]);
				}
				Db::name('config')->commit();
			} catch (\Exception $e) {
				Db::name('config')->rollback();
			}
			$this->success(OK, 'basic');
		}
		$list = ConfigModel::all(['type' => ['in', '2,3']]);
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 上传设置
	public function upload()
	{
		if (input('sub')) {
			$data = request()->post();
			foreach ($data as $key => $val) {
				if($key == "upload_file_ext" || $key == "upload_image_ext" || $key == "upload_video_ext" || $key == "upload_audio_ext"){
			        $arr = explode(",", $val);
			        foreach ($arr as $k => $v){
			            if($v == "php" || $v == "html" || $v == "js" || $v == "shell" || $v == "bat" || $v == "PHP" || $v == "HTML" || $v == "JS" || $v == "SHELL" || $v == "BAT"){
			                $this->error('上传格式不能含有.php, .html, .js, .shell, .bat 等文件');
			            }
			        }
			    }
				ConfigModel::where('tag', $key)->update(['val' => $val]);
			}
			$this->success(OK, 'upload');
		}
		$list = ConfigModel::all(['type' => 4]);
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 水印设置
	public function water()
	{
		if (input('sub')) {
			$config_model = new ConfigModel();
			$data = request()->post();
			$array = [];
			$status = $data['water_type'];	//1：不加水印；2：文字水印；3：图片水印
			if ($status == 1) {
				$res = ['show_type' => 1, 'val' => ''];
			} else if ($status == 2) {
				if (isset($data['watermark_position']) == false) {
					$data['watermark_position'] = '';
				}
				foreach ($data as $k => $v) {
					if (empty($v)) {
						unset($data[$k]);
					}
					switch ($k) {
						case 'watermark_position':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'watermark_word':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'watermark_size':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'watermark_pixel':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'watermark_color':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
					}
				}
				$str = '';
				for ($i = 0; $i < count($array); $i++) {
					if ($i == 0) {
						$str .= $array[$i];
					} else {
						if ($i == 2 && $array[$i] > 18) {
							$this->error('文字水印像素过大，最大为18像素');
						}
						$str .= '%' . $array[$i];
					}
				}
				$res = ['val' => $str, 'show_type' => 2];
			} else if ($status == 3) {
				if (isset($data['watermark_positions']) == false) {
					$data['watermark_positions'] = '';
				}
				foreach ($data as $k => $v) {
					if (empty($v)) {
						unset($data[$k]);
					}
					switch ($k) {
						case 'watermark_positions':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'content2':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
						case 'transparency':
							$data[$k] = empty($data[$k]) ? 0 : $data[$k];
							array_push($array, $data[$k]);
							unset($data[$k]);
							break;
					}
					$str = '';
					for ($i = 0; $i < count($array); $i++) {
						if ($i == 0) {
							$str .= $array[$i];
						} else {
							$str .= '%' . $array[$i];
						}
					}
					$res = ['val' => $str, 'show_type' => 3];
				}
			}

			$type = $config_model->insert_configure('upload_watermark', $res);
			if ($type) {
				$this->success(OK);
			} else {
				$this->error(FAIL);
			}
		}

		$upload_watermark = ConfigModel::get(16);
		$watermark = explode('%', $upload_watermark['val']);
		$count = count($watermark);
		if ($count == 1) {		//没有水印
			$this->assign('watermark', null);
			$this->assign('imgs', null);
		} else if ($count == 3) {	//图片水印
			$this->assign('watermark', null);
			$this->assign('imgs', $watermark);	
		} else {	//文字水印
			$this->assign('watermark', $watermark);
			$this->assign('imgs', null);
		}
		$this->assign('show_type', $upload_watermark['show_type']);

		//dump($watermark);
		return $this->fetch();
	}

	// 邮箱设置
	public function email()
	{
		if (input('sub')) {
			$data = request()->post();
			foreach ($data as $key => $val) {
				ConfigModel::where('tag', $key)->update(['val' => $val]);
			}
			$this->success(OK, 'email');
		}
		$list = ConfigModel::all(['type' => 6]);
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 友情链接
	public function link()
	{
		$list = Link::all(function ($query) {
			$query->order('rank asc, id asc');
		});
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 友情链接 - 添加
	public function linkAdd()
	{
		if (input('sub')) {
			$data = request()->post();

			$file = request()->file('img');
			if (isset($file)) {
				$info = $file->move(ROOT_PATH . 'public' . DS . 'uploads');
				if (!$info) {
					$this->error('图片传输有误');
				}
				$data['img'] = '/uploads/' . date('Ymd') . '/' . $info->getFilename();
			}

			$link_model = new Link;
			$res = $link_model->allowField(true)->save($data);

			$res ? $this->success(OK, 'link') : $this->error(FAIL);
		}

		return $this->fetch();
	}

	// 友情链接 - 编辑
	public function linkEdit($id)
	{
		if (input('sub')) {
			if (input('type')) {
				$res = Link::where('id', $id)->update([input('type')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
			} else {
				$data = request()->post();
				$link_model = new Link;
				$res = $link_model->allowField(true)->save($data, ['id' => $id]);
				$res ? $this->success(OK, 'link') : $this->error(FAIL);
			}
		}

		$res = Link::get($id);
		$this->assign('res', $res);

		return $this->fetch();
	}

	// 友情链接 - 删除
	public function linkDel($id)
	{
		$res = link::destroy(['id' => ['in', $id]]);
		return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
	}


	// 轮播管理
	public function banner()
	{
		$list = Banner::all(function ($e) {
			$e->order('rank asc');
		});
		$this->assign('list', $list);
		return $this->fetch();
	}

	// 轮播管理 - 添加
	public function bannerAdd()
	{
		if (input('sub')) {
			$data = request()->post();

			if ($data['img'] == '') {
				$this->error('图片不能为空');
			}

			$banner_model = new Banner;
			$res = $banner_model->allowField(true)->save($data);

			$res ? $this->success(OK, 'banner') : $this->error(FAIL);
		}
		return $this->fetch();
	}

	// 轮播管理 - 编辑
	public function bannerEdit($id)
	{
		if (input('sub')) {
			if (input('typer')) {
				$res = Banner::where('id', $id)->update([input('typer')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
			} else {
				$data = request()->post();

				if ($data['img'] == '') {
					$this->error('图片不能为空');
				}
	
				$banner_model = new Banner;
				$res = $banner_model->allowField(true)->save($data, ['id' => $id]);
	
				$res ? $this->success(OK, 'banner') : $this->error(FAIL);
			}
		}

		$res = Banner::get($id);
		$this->assign('res', $res);

		return $this->fetch();
	}

	// 轮播管理 - 删除
	public function bannerDel($id)
	{
		$res = Banner::destroy(['id' => ['in', $id]]);
		return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
	}

	//站点地图
	public function sitemap()
	{
		$this->createSitemap();
		return $this->fetch();
	}

	///更新站点地图
	public function upsitemap()
	{
		$this->createSitemap();
		$data = ['state' => 1, 'msg' => '更新站点地图成功'];
		return json_encode($data);
	}

	//更新站点地图
	public function createSitemap()
	{
		$category = new Category();
		$content = new Content();
		$list = ConfigModel::all(['type' => 1])->toArray();
		$siteurl = $_SERVER['REQUEST_SCHEME'] . "://" . $_SERVER['SERVER_NAME'];
		//因为前端显示栏目并没有分配管理员权限，所以默认全部显示，后期加权限再处理
		$conurl_list = [];
		$cateurl_list = [];
		$catelist = $category->getAllCategory(); //查找所有栏目
		$contentList = $content->getAllContent(); ///查找所有内容
		foreach ($catelist as $k => $v) {
			$cateurl_list[] = [
				'cateurl' => $siteurl . '/index/category/index&id=' . $catelist[$k]['id'], //路径
				'title' => $catelist[$k]['seo_title'], //seo描述
				'keywords' => $catelist[$k]['seo_keywords'], //seo关键词
				'describe' => $catelist[$k]['seo_describe'], //seo描述
			]; //给栏目添加路径方便做搜索引擎优化
		}
		foreach ($contentList as $key => $val) {
			$conurl_list[] = [
				'cateurl' => $siteurl . '/index/show/index&id=' . $contentList[$key]['id'], //路径
				'title' => $contentList[$key]['seo_title'], //seo描述
				'keywords' => $contentList[$key]['seo_keywords'], //seo关键词
				'describe' => $contentList[$key]['seo_describe'], //seo描述
			];
		}

		//(sitemap.xml 谷歌引擎所需)
		//站点地图
		$sitemap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\">\r\n";
		$sitemap .= "<url>\r\n" . "<loc><![CDATA[" . $siteurl . "]]></loc>\r\n" . "<priority><![CDATA[1.0]]></priority>\r\n<lastmod><![CDATA[" . date('Y-m-d') . "]]></lastmod>\r\n<changefreq><![CDATA[daily]]></changefreq>\r\n</url>\r\n";
		foreach ($cateurl_list as $k => $v) {
			$sitemap .= "<url>\r\n" . "<loc><![CDATA[" . $v['cateurl'] . "]]></loc>\r\n" . "<priority><![CDATA[0.8]]></priority>\r\n<lastmod><![CDATA[" . date('Y-m-d') . "]]></lastmod>\r\n<changefreq><![CDATA[weekly]]></changefreq>\r\n</url>\r\n";
		}
		foreach ($conurl_list as $k => $v) {
			$sitemap .= "<url>\r\n" . "<loc><![CDATA[" . $v['cateurl'] . "]]></loc>\r\n" . "<priority><![CDATA[0.9]]></priority>\r\n<lastmod><![CDATA[" . date('Y-m-d') . "]]></lastmod>\r\n<changefreq><![CDATA[weekly]]></changefreq>\r\n</url>\r\n";
		}
		$sitemap .= '</urlset>';
		$file = fopen("./map/sitemap.xml", "w");

		fwrite($file, $sitemap);
		fclose($file);
		//rss（统一标准数据接口）
		$rss = "<rss version=\"2.0\">\r\n";
		$rss .= "<channel>\r\n";

		$rss .= "<title><![CDATA[" . $list[0]['val'] . "]]></title>\r\n"; //名称（title）
		$rss .= "<category><![CDATA[" . $list[1]['val'] . "]]></category>\r\n"; //关键字（key）
		$rss .= "<description><![CDATA[" . $list[2]['val'] . "]]></description>\r\n"; //描述（des）
		$rss .= "<link><![CDATA[" . $siteurl . "]]></link>\r\n";
		$rss .= "<language>zh_CN</language>\r\n";
		$rss .= "<pubDate>" . date('Y-m-d H:i:s') . "</pubDate>\r\n";
		$rss .= "<lastBuildDate>" . date('Y-m-d H:i:s') . "</lastBuildDate>\r\n";
		$rss .= "<generator>jdcms RSS Generator</generator>\r\n";
		$rss .= "<ttl>5</ttl>\r\n";

		foreach ($cateurl_list as $k => $v) {
			$rss .= "<item>\r\n";
			$rss .= "<title><![CDATA[" . $v['title'] . "]]></title>\r\n";
			$rss .= "<description><![CDATA[" . $v['describe'] . "]]></description>\r\n";
			$rss .= "<link><![CDATA[" . $v['cateurl'] . "]]></link>\r\n";
			$rss .= "</item>\r\n";
		}

		foreach ($conurl_list as $k => $v) {
			$rss .= "<item>\r\n";
			$rss .= "<title><![CDATA[" . $v['title'] . "]]></title>\r\n";
			$rss .= "<description><![CDATA[" . $v['describe'] . "]]></description>\r\n";
			$rss .= "<link><![CDATA[" . $v['cateurl'] . "]]></link>\r\n";
			$rss .= "</item>\r\n";
		}

		$rss .= "</channel>\r\n";
		$rss .= "</rss>";
		$rssfile = fopen("./map/rss.xml", "w");

		fwrite($rssfile, $rss);
		fclose($rssfile);
		//txt(yahoo搜索引擎所需)html(百度搜索引擎所需)
		$txt = "";
		$html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\r\n";
		$html .= "<html xmlns=\"http://www.w3.org/1999/xhtml\">\r\n";
		$html .= "<head>\r\n";
		$html .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\r\n";
		$html .= "<title>html网站地图</title>\r\n";
		$html .= "</head>\r\n";
		$html .= "<body id=\"main_page\">\r\n";

		foreach ($cateurl_list as $k => $v) {
			$html .= "<li><a href='" . $v['cateurl'] . "' title='" . $v['title'] . "' target='_blank'>" . $v['title'] . "</a><span>" . $v['describe'] . "</span></li>\r\n";
			$txt .= $v['cateurl'] . "\r\n";
		}

		foreach ($conurl_list as $k => $v) {
			$html .= "<li><a href='" . $v['cateurl'] . "' title='" . $v['title'] . "' target='_blank'>" . $v['title'] . "</a><span>" . $v['describe'] . "</span></li>\r\n";
			$txt .= $v['cateurl'] . "\r\n";
		}

		$html .= "</body>\r\n";
		$html .= "</html>\r\n";

		$file = fopen("./map/sitemap.htm", "w");
		fwrite($file, $html);
		fclose($file);

		$file = fopen("./map/sitemap.txt", "w");
		fwrite($file, $txt);
		fclose($file);
	}
}
