<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Content as ContentModel;
use app\admin\model\Category;
use app\admin\model\DiyField;
use app\admin\model\AdminRole as role;

class Content extends Base
{
    // 内容管理
    public function index()
    {
        $list = Category::all(function ($e) {
            $e->order('rank asc');
        });
        $list = isset($list) ? $list->toArray() : [];
        $list = rule($list);
        $admin_role = session('admin')['role'];
        if ($admin_role != 1) {
            $role = new role();
            $roles = $role->findRole($admin_role);
            $column = $roles['column_list'];
            $column = explode(',', $column);
            foreach ($list as $k => $v) {
                if (in_array($list[$k]['id'], $column)) {   // 权限判断
                    $list[$k]['style'] = 1;
                } else {
                    $list[$k]['style'] = 2;
                }
            }
        } else {
            foreach ($list as $k => $v) {
                $list[$k]['style'] = 1;
            }
        }

        foreach ($list as $k => $v) {
            $list[$k]['num'] = ContentModel::where('cid', $v['id'])->count();
        }
        $this->assign('list', $list);

        // 内容页展示内容
        if (input('cid')) {
            $content_list = ContentModel::all(function ($e) {
                $e->where('cid', input('cid'))->order('rank asc');
            });
            $content_list = isset($content_list) ? $content_list->toArray() : [];
            $this->assign('content_list', $content_list);

            $cat = Category::get(input('cid'));
            $this->assign('cat_name', $cat['title']);
        }

        return $this->fetch();
    }

    // 内容管理 - 添加
    public function add($cid)
    {
        if (input('sub')) {
            $data = request()->post();
            $cat  = Category::get($cid);    // 栏目信息

            $data['cid'] = $cid;            // 栏目分类要手动加进去，这个是get传值，post获取不到
            $data['mid'] = $cat['mid'];     // 模板id加进去，需要通过模板id获取对应的操作表

            $content_model = new ContentModel;
            $res = $content_model->insertContent($data);
            if ($res['status']) {
                $this->success(OK, url('index', ['cid' => $cid]));
            } else {
                $this->error($res['msg']);
            }
        }

        $cat  = Category::get($cid);    // 栏目信息

        $field_list = DiyField::all(function ($e) use ($cat) {
            $e->where('mid', $cat['mid'])->where('type', 1)->order('rank asc, id asc');
        });
        $content = $this->get_all_diy_field($field_list);
        $this->assign('content', $content);

        return $this->fetch();
    }

    // 内容管理 - 编辑
    public function edit($id)
    {
        if (input('sub')) {
            if (input('type')) {		// sub, id, type, value
				$res = ContentModel::where('id', $id)->update([input('type')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
			} else {
                $data = request()->post();
                $content_model = new ContentModel;
                $res = $content_model->updateContent($data, $id);
                if ($res['status'] == 1) {
                    $this->success(OK, url('index', ['cid' => $res['cid']]));
                } else {
                    $this->error($res['msg']);
                }
            }
        }

        $content_model = new ContentModel;
        $res  = $content_model->getOneContent($id);         // 获取内容
        $cat  = Category::get($res['cid']);                 // 栏目信息

        $field_list = DiyField::all(function ($e) use ($cat) {
            $e->where('mid', $cat['mid'])->where('type', 1)->order('rank asc, id asc');
        });         // 自定义字段信息

        $content = $this->get_all_diy_field($field_list, $res);

        $this->assign('res', $res);
        $this->assign('content', $content);

        return $this->fetch();
    }

    // 内容管理 - 删除
    public function del($id)
    {
        $content_model = new ContentModel;
        $res = $content_model->deleteContent($id);
        return $res['status'] == 1 ? ['status' => 1, 'msg' => $res['msg']] : ['status' => 0, 'msg' => $res['msg']];
    }

    // 内容管理 - 批量操作 type 1批量SEO设置
    public function batch($type)
    {
        $post = request()->post();
        $ids = explode(',', $post['id']);
        if (count($ids) == 0) {
            return ['status' => -1, 'msg' => '请选择内容'];
        }
        switch ($type) {
            case 1:
                $data = [
                    'seo_title'     => $post['seo_title'],
                    'seo_keywords'  => $post['seo_keywords'],
                    'seo_describe'  => $post['seo_describe'],
                ];
                $res = ContentModel::where('id', 'in', $ids)->update($data);
                return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
                break;
            case 2:
                $res = ContentModel::where('id', 'in', $ids)->update(['recommend' => 1]);
                return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
                break;
            case 3:
                $res = ContentModel::where('id', 'in', $ids)->update(['recommend' => 2]);
                return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
                break;
            default:
                return ['status' => 0, 'msg' => FAIL];
                break;
        }
    }

    // 获取对应表单的字段信息
    public function get_all_diy_field($field_list, $val_list = [])
    {
        $html = '';
        $script = '';
        $hs_editor = 0;
        $hs_img = 0;
        foreach ($field_list as $k => $v) {
            $req = $v['is_not_null'] ? 'required' : '';
            $val = array_key_exists($v['field'], $val_list) ? $val_list[$v['field']] : $v['default_value'];
            switch ($v['field_type']) {
                case '------':      // 分组线
                    $html .=    '<div class="col-md-12">
                                    <p class="block-tit col-md-12 col-xs-12">
                                        <b>'.$v['remark'].'</b>
                                        <span></span>
                                    </p>
                                </div>';
                    break;
                case 'text':        //单行文本
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="text" name="'.$v['field'].'" value="'.$val.'" '.$req.' />
                                        <b class="col-md-8">'.$v['remark'].'</b>
                                    </div>
                                </label>';
                    break;
                case 'textarea':    // 多行文本
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <textarea name="'.$v['field'].'" class="form-control col-md-5" '.$req.'>'.$val.'</textarea>
                                        <b class="col-md-8"></b>
                                    </div>
                                </label>';
                    break;
                case 'seditor':     // 简约编辑器
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <textarea name="'.$v['field'].'" id="'.$v['field'].'">'.$val.'</textarea>
                                        <b class="col-md-8"></b>
                                    </div>
                                </label>';
                    if ($hs_editor == 0) {
                        $script .=   '<script type="text/javascript" charset="utf-8" src="/static/plug/ue/ueditor.config.js"></script>
                                    <script type="text/javascript" charset="utf-8" src="/static/plug/ue/ueditor.all.min.js"></script>
                                    <script type="text/javascript" charset="utf-8" src="/static/plug/ue/lang/zh-cn/zh-cn.js"></script>';
                    }
                    $script .=  '<script>
                                    var option = {
                                        toolbars: [[
                                            "fullscreen", "source", "|", "bold", "italic", "underline", "strikethrough", "forecolor", "backcolor", "paragraph", "fontfamily", "fontsize", "|",
                                            "indent", "justifyleft", "justifycenter", "justifyright", "justifyjustify", "|", "link", "unlink",
                                        ]]
                                    };
                                    var ue_'.$v['field'].' = UE.getEditor("'.$v['field'].'", option);
                                </script>';
                    $hs_editor = 1;
                    break;
                case 'editor':      // 富文本编辑器
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <textarea style="height:300px;" name="'.$v['field'].'" id="'.$v['field'].'">'.$val.'</textarea>
                                        <b class="col-md-8"></b>
                                    </div>
                                </label>';
                    if ($hs_editor == 0) {
                        $script .=   '<script type="text/javascript" charset="utf-8" src="/static/plug/ue/ueditor.config.js"></script>
                                    <script type="text/javascript" charset="utf-8" src="/static/plug/ue/ueditor.all.min.js"></script>
                                    <script type="text/javascript" charset="utf-8" src="/static/plug/ue/lang/zh-cn/zh-cn.js"></script>';
                    }
                    $script .=  '<script>
                                    var ue_'.$v['field'].' = UE.getEditor("'.$v['field'].'");
                                </script>';
                    $hs_editor = 1;
                    break;
                case 'file':        // 附件
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="text" value="'.$val.'" name="'.$v['field'].'" />
                                        <div class="layui-upload col-md-8"  style="position: relative;">
                                            <input onchange="sel_file(this)" type="file" data-type="file" class="layui-btn btn-bgfff img-src">
                                            <span class="img-span">
                                                <img src="/static/assets/img/upload.png" style="margin-right: 4px;">选择文件
                                            </span>
                                        </div>
                                    </div>
                                </label>';
                    break;
                case 'image':       // 单图
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5 bind-'.$v['field'].'" type="text" value="'.$val.'" name="'.$v['field'].'" />
                                        <div class="layui-upload col-md-8"  style="position: relative;">
                                            <button type="button" class="layui-btn btn-blue chooseimg" data-bind-class="bind-'.$v['field'].'" onclick="btn_select(this)" data-method="notice">选择站内图片</button>
                                            <input onchange="btn_change(this)" type="file" class="layui-btn btn-bgfff img-src">
                                            <span class="img-span">
                                                <img src="/static/assets/img/upload.png" style="margin-right: 4px;">本地上传图片
                                            </span>
                                        </div>
                                        <div class="layui-upload-list col-md-12">
                                            <img class="layui-upload-img" src="'.$val.'">
                                        </div>
                                    </div>
                                </label>';
                    break;
                case 'images':      // 多图
                    $img_str = '';
                    if ($val) {
                        $img_list = explode(',', $val);
                        foreach ($img_list as $k1 => $v1) {
                            $img_str .= '<span class="img-out-span"> 
                                            <img class="layui-upload-img" src="'.$v1.'"> 
                                            <input type="hidden" name="'.$v['field'].'[]" value="'.$v1.'"> 
                                            <span class="img-del-span" onclick="imgDel(this);">删除</span> 
                                        </span>';
                        }
                    }
                    $html .=    '<div class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5 bind-'.$v['field'].'" type="hidden" data-img-many="1" data-name="'.$v['field'].'"/>
                                        <div class="layui-upload col-md-8"  style="position: relative;">
                                            <button type="button" class="layui-btn btn-blue chooseimg" data-bind-class="bind-'.$v['field'].'" onclick="btn_select(this)" data-method="notice">选择站内图片</button>
                                            <input onchange="btn_change(this)" data-img-many="1" data-name="'.$v['field'].'" type="file" class="layui-btn btn-bgfff img-src">
                                            <span class="img-span">
                                                <img src="/static/assets/img/upload.png" style="margin-right: 4px;">本地上传图片
                                            </span>
                                        </div>      
                                        <div class="layui-upload-list col-md-12">
                                        ' . $img_str . '
                                        </div>
                                    </div>
                                </div>';
                    break;
                case 'datetime':    //日期和时间
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="date" name="'.$v['field'].'" value="'.substr($val, 0, 10).'" '.$req.' />
                                        <b class="col-md-8">'.$v['remark'].'</b>
                                    </div>
                                </label>';
                    break;
                
                case 'number':      //数字
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="number" name="'.$v['field'].'" value="'.$val.'" '.$req.' />
                                        <b class="col-md-8">'.$v['remark'].'</b>
                                    </div>
                                </label>';
                    break;
                case 'radio':       // 单选
                    $values = explode("/", $v['default_value']);
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">';
                    $a = 0;
                    foreach ($values as $k1 => $v1) {
                        $check = ($v1 == $val) || ($v['is_not_null'] && $a == 0) ? "checked" : '';
                        $html .=        '<label style="margin-right: 30px;"><input type="radio" name="'.$v['field'].'" value="'.$v1.'" '.$check.'>'.$v1.'</label>';
                        $a++;
                    }
                    $html .=        '</div>
                                    <b class="col-md-8">'.$v['remark'].'</b>
                                </label>';
                    break;
                case 'checkbox':    // 复选框
                    $values = explode("/", $v['default_value']);
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12 layui-input-block">';
                    $a = 0;
                    $val_arr = explode(',', $val);
                    foreach ($values as $k1 => $v1) {
                        $check = (in_array($v1, $val_arr)) || ($v['is_not_null'] && $a == 0) ? "checked" : '';
                        $html .=        '<input type="checkbox" name="'.$v['field'].'[]" value="'.$v1.'" lay-skin="primary" '.$check.' title="'.$v1.'">';
                        $a++;
                    }
                    $html .=        '</div>
                                </label>';
                    break;
                case 'select':      // 下拉框
                    $values = explode("/", $v['default_value']);
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <select name="'.$v['field'].'">';
                    $a = 0;
                    foreach ($values as $k1 => $v1) {
                        $selected = ($v1 == $val) || ($v['is_not_null'] && $a == 0) ? "selected" : '';
                        $html .=            '<option value="'. $v1.'"' . $selected . '>' . $v1 . '</option>';
                        $a++;
                    }
                    $html .=            '</select>
                                    </div>
                                </label>';
                    break;

                case 'video':        // 视频
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="text" value="'.$val.'" name="'.$v['field'].'" />
                                        <div class="layui-upload col-md-8"  style="position: relative;">
                                            <input onchange="sel_file(this)" type="file" data-type="video" class="layui-btn btn-bgfff img-src">
                                            <span class="img-span">
                                                <img src="/static/assets/img/upload.png" style="margin-right: 4px;">选择视频
                                            </span>
                                        </div>
                                    </div>
                                </label>';
                    break;
                case 'audio':        // 音频
                    $html .=    '<label class="col-md-12 col-xs-12">
                                    <span class="col-md-1_5 col-xs-12">'.$v['name'].'</span>
                                    <div class="col-md-10_5 col-xs-12">
                                        <input class="form-control col-md-5" type="text" value="'.$val.'" name="'.$v['field'].'" />
                                        <div class="layui-upload col-md-8"  style="position: relative;">
                                            <input onchange="sel_file(this)" type="file" data-type="audio" class="layui-btn btn-bgfff img-src">
                                            <span class="img-span">
                                                <img src="/static/assets/img/upload.png" style="margin-right: 4px;">选择音频
                                            </span>
                                        </div>
                                    </div>
                                </label>';
                    break;

                default:
                    break;
            }
        }

        return ['html' => $html, 'script' => $script];
    }
}
