<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | DREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use think\Db;

use app\admin\controller\BackSql;

class Data extends Base
{
    public function index()
    {
        $tmp = Db::query('SHOW TABLE STATUS');
        $list = array_map('array_change_key_case', $tmp);
        foreach ($list as $k => $v) {
            if ($v['data_length']>0 && $v['data_length'] <= 1024) {
                $list[$k]['data_length']= 1;
            } else {
                $list[$k]['data_length'] = ceil($v['data_length']/1024);
            }
            $list[$k]['data_length'] = $list[$k]['data_length'].'KB';

            if (substr($v['name'], 0, 7) == 'jd_diy_') {
                $comment = Db::name('auth_model')->where('table_name', substr($v['name'], 7))->value('remark');
                if ($comment) {
                    $list[$k]['comment'] = $comment;
                }
                $list[$k]['type'] = '<span class="text-success"> 自定义表 </span>';
            } else if (substr($v['name'], 0, 8) == 'jd_form_') {
                $comment = Db::name('auth_form')->where('table_name', substr($v['name'], 8))->value('remark');
                if ($comment) {
                    $list[$k]['comment'] = $comment;
                }
                $list[$k]['type'] = '<span class="text-success"> 自定义表 </span>';
            } else {
                $list[$k]['type'] = '<span class="text-primary"> 系统表 </span>';
            }
        }
        $this->assign('list', $list);
        return $this->fetch();
    }

    //备份数据库
    public function export($id)
    {
        $sql = new BackSql(\think\Config::get("database"));
        $arr = explode(',',$id);
        $info = $sql->backup($arr);
        return $info;
    }

    //数据库表优化
    public function optimize($id = null)
    {
        if (empty($id)) {
            return $this->error("请指定要优化的表！");
        }
        $id = explode(',', $id);
        if (is_array($id)) {
            $tables = implode('`,`', $id);
            $list = Db::query("OPTIMIZE TABLE `{$tables}`");
            if($list){
                return ['status' => 1, 'msg' => '数据表优化完成'];
            } else {
                return ['status' => 0, 'msg' => '数据表优化出错请重试！'];
            }
        }
    }

    //数据库表修复
    public function repair($id = null)
    {
        if (empty($id)) {
            return $this->error("请指定要修复的表！");
        }
        $id = explode(',', $id);
        if (is_array($id)) {
            $tables = implode('`,`', $id);
            $list = Db::query("REPAIR TABLE `{$tables}`");
            if($list){
                return ['status' => 1, 'msg' => '数据表修复完成'];
            } else {
                return ['status' => 0, 'msg' => '数据表修复出错啦！'];
            }
        }
    }

    //还原数据库
    public function import()
    {
        //读取数据库备份文件
        $dir = ROOT_PATH . 'data/';
        //SQL文件数组
        $list = [];
        if (is_dir($dir)) {
            $fileList = scandir($dir);
            foreach ($fileList as $key => $val) {
                if( $val=='.' ||  $val=='..'){
                    continue;
                }
                //文件名称
                $list[$key]['name'] = $val;
                //时间
                $list[$key]['time'] = date('Y-m-d H:i:s',filemtime($dir.'/'.$val));
                //大小
                $filesize = filesize($dir.'/'.$val);
                if ($filesize>0 && $filesize<=1024) {
                    $filesize=1;
                } else {
                    $filesize=ceil($filesize/1024);
                }
                $list[$key]['size'] = $filesize.'KB';
            }
            if (count($list) > 0) {
                $this->assign('list',$list);
            }
        } else {
            echo '目录不存在';
        }
        return $this->fetch();
    }

    //删除数据表
    public function do_del($name = null) 
    {
        empty($name) && $this->error('参数错误！');
        $path = realpath(config('data_backup_path')) . DIRECTORY_SEPARATOR . $name;
        array_map("unlink", glob($path));
        if (count(glob($path))) {
            return $this->error('备份文件删除失败，请检查权限！');
        } else {
            return $this->success('备份文件删除成功！');
        }
    }

    //数据表还原
    public function revert($name = null) {
        $sql = new BackSql(\think\Config::get("database"));
        $info = $sql->restore($name);
        return $info;
    }
}
