<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\DiyField;
use app\admin\model\DiyForm;
use think\Db;

class Diyforms extends Base
{
    public $fields;

    public function __construct()
    {
        parent::__construct();
        $get_diy_form   = get_diy_form();
        $this->fields   = $get_diy_form['fields'];     // 自定义表的所有字段类型
        $this->formtype = $get_diy_form['formtype'];   // 自定义表的所有字段类型对应的数据库字段类型
    }

    // 表单管理 - 表单列表
    public function index()
    {
        $form_model     = new DiyForm();
        $field_moedel   = new DiyField();
        $list = $form_model->selectAllForm();
        foreach ($list as $k => $V) {
            $list[$k]['count'] = $field_moedel->getAllFieldCount($list[$k]['id'], 2);
            $list[$k]['record'] = Db::name('form_' . $list[$k]['table_name'])->count();
        }
        $this->assign('list', $list);

        return $this->fetch();
    }

    // 表单管理 - 添加表单
    public function add()
    {
        if (input('sub')) {
            $data = request()->post();

            $diy_form_model = new DiyForm();
            $res = $diy_form_model->insertForm($data);

            if ($res['status'] == 1) {
                $sql = "CREATE TABLE `" . config('database.prefix') . "form_" . $data['table_name'] . "` (`id` INT(10) PRIMARY KEY NOT NULL AUTO_INCREMENT)";
                Db::execute($sql);
                $this->success(OK, "index");
            } else {
                $this->error($res['msg']);
            }
        }

        return $this->fetch();
    }

    // 表单管理 - 编辑表单
    public function edit($id)
    {
        if (input('sub')) {
            if (input('type')) {
                $res = DiyForm::where('id', $id)->update([input('type') => input('value')]);
                return $res ? ['status' => 1, 'msg' => 'OK'] : ['status' => 0, 'msg' => FAIL];
            } else {
                $data = request()->post();

                $table = DiyForm::get($id);
                $table_name = $table['table_name'];

                $diy_form_model = new DiyForm();
                $res = $diy_form_model->updateForm($id, $data);

                if ($res['status'] == 1) {
                    $sql = "ALTER TABLE " . config('database.prefix') . "form_" . $table_name . " RENAME TO " . config('database.prefix') . "form_" . $data['table_name'] . ";";
                    Db::execute($sql);
                    return $this->success(OK, 'index');
                } else {
                    return $this->error($res['msg']);
                }
            }
        }

        $res = DiyForm::get($id);
        $this->assign('res', $res);

        return $this->fetch();
    }

    // 表单管理 - 复制表单
    public function copy($id)
    {
        $diy_form_model = new DiyForm();
        $info = $diy_form_model->findForm($id);
        unset($info['id']);
        $ytabname = $info['table_name'];
        $rand_eng = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'];
        $rand_size = array_rand($rand_eng, 5);
        $copytabname = $rand_eng[$rand_size[0]] . $rand_eng[$rand_size[1]] . $rand_eng[$rand_size[2]];
        if (strlen($ytabname) > 20) {
            return $this->error('数据表名长度不能超过20');
        }
        $info['name']       = $info['name'] . $copytabname;
        $info['table_name'] = $info['table_name'] . $copytabname;
        $info['remark']     = $info['remark'];
        $info['is_verify']  = $info['is_verify'];
        $info['rank']       = $info['rank'];
        $info['is_send_email']  = $info['is_send_email'];
        $info['email']          = $info['email'];
        $info['email_title']    = $info['email_title'];
        $info['email_content']  = $info['email_content'];
        $flag = $diy_form_model->insertForm($info);

        if ($flag) {
            //复制数据表
            $sql = "CREATE TABLE `" . config('database.prefix') . "form_" . $info['table_name'] . "` SELECT * FROM `" . config('database.prefix') . "form_" . $ytabname . "` where 0";
            Db::execute($sql);
            //设置主键
            $sql = "ALTER TABLE `" . config('database.prefix') . "form_" . $info['table_name'] . "` modify id int AUTO_INCREMENT PRIMARY KEY";
            Db::execute($sql);
            //复制字段管理数据
            $jg = $diy_form_model->copyDiymodelField($ytabname, $info['table_name']);
            if ($jg['code'] == 1) {
                return ['status' => 1, 'msg' => '复制模型成功'];
            } else {
                return ['status' => 0, 'msg' => FAIL];
            }
        } else {
            return ['status' => 0, 'msg' => $flag['msg']];
        }
    }

    // 表单管理 - 删除表单
    public function del($id)
    {
        $diy_form_model  = new DiyForm();
        $diy_field_model = new DiyField();
        $table = $diy_form_model->findForm($id);
        $table_name = $table['table_name'];
        try {
            $diy_form_model->delForm($id);
            $diy_field_model->delFieldForm($id);
        } catch (\Exception $e) {
            $this->error('删除表单失败');
        }
        //删除数据表名
        $sql = "DROP TABLE `" . config('database.prefix') . "form_" . $table_name . "`";
        Db::execute($sql);
        return ['status' => 1, 'msg' => OK];
    }

    // 表单管理 - 快速开关验证
    public function verification($id, $type, $field)
    {
        if ($type == 1) {
            $is_verify = 0;
        } else {
            $is_verify = 1;
        }
        $res = DiyForm::where('id', $id)->update([$field => $is_verify]);

        return $res ? ['status' => 1, 'msg' => OK] : ['status' => 0, 'msg' => FAIL];
    }

    // 表单管理 - 表单字段
    public function field($id)
    {
        $diy_field_model = new DiyField();
        $list = $diy_field_model->selectFormField($id);
        $fields = $this->fields;
        if ($list) {
            foreach ($list as $k => $v){
                foreach ($fields as $key => $val){
                    if ($list[$k]['field_type'] == $key){
                        $list[$k]['field_type'] = $val;
                    }
                }
            }
        } else {
            $list = [];
        }
        $this->assign('list', $list);
        return $this->fetch();
    }

    // 表单管理 - 添加表单字段
    public function fieldAdd()
    {
        if (input('sub')) {
            $diy_field_model = new DiyField();
            $diy_model_model = new DiyForm();

            $data = $input = request()->param();
            $data['type'] = 2;
            $fields =  $this->fields;       // 获取支持的所有文本类型
            $types  =  $this->formtype;     // 获取文本类型对应的字段类型
            $type   = '';                   // 字段类型
            foreach ($fields as $k => $v) {
                if ($k == $input['field_type']) {
                    foreach ($types as $key => $val) {
                        if ($k == $key) {
                            $type = $val;
                        }
                    }
                }
            }

            $selectField = $diy_field_model->selectField($input['mid']);  // 获取本模型所有字段
            if ($selectField) {
                $arr = [];
                foreach ($selectField as $k => $v) {
                    array_push($arr, $selectField[$k]['field']);
                }
                if (in_array($data['field'], $arr) == true) {
                    return $this->error('字段名称重复');
                }
            }

            $models = $diy_model_model->findForm($input['mid']);
            $table_name = config('database.prefix') . "form_" . $models['table_name'];   // 获取模型对应表

            $res = $diy_field_model->insertField($data);

            if ($res['status'] == 1) {
                switch ($type) {
                    case 'varchar':
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` VARCHAR({$input['length']}) DEFAULT '{$data["default_value"]}'";
                        Db::execute($sql);
                        break;
                    case 'int':
                        $default_value = intval($data["default_value"]);
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` INT(11) UNSIGNED DEFAULT '{$default_value}'";
                        Db::execute($sql);
                        break;
                    case 'smallint':
                        $default_value = intval($data["default_value"]);
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` SMALLINT(5) UNSIGNED DEFAULT '{$default_value}'";
                        Db::execute($sql);
                        break;
                    case 'text':
                        Db::execute("ALTER TABLE `{$table_name}` ADD `{$input['field']}` TEXT");
                        break;
                }
                $this->success('添加字段成功', url('field', ['id' => $input['mid']]));
            } else {
                $this->error($res['msg']);
            }
        }

        $this->assign('checkbox', $this->fields);
        return $this->fetch();
    }

    // 表单管理 - 编辑表单字段
    public function fieldEdit($id)
    {
        if (input('sub')) {
            $data = $input = request()->param();

            $field = new DiyField();
            $form  = new DiyForm();

            $fields =  $this->fields;
            $type   =  $this->formtype;
            $types  = '';
            foreach ($fields as $k => $v) {
                if ($k == $input['field_type']) {
                    foreach ($type as $key => $val) {
                        if ($k == $key) {
                            $types = $val;
                        }
                    }
                }
            }

            $selectField = $field->selectFormField($input['mid']);
            $list = '';
            $arr = [];
            foreach ($selectField as $k => $v) {
                array_push($arr, $selectField[$k]['field']);
            }
            foreach ($selectField as $key => $val) {
                if ($input['id'] == $val['id']) {
                    $list = $val['field'];
                }
                if ($input['id'] != $val['id'] && $input['field'] == $val['field']) {
                    return $this->error('字段名称重复');
                }
            }
            $forms = $form->findForm($input['mid']);
            $tablename = config('database.prefix') . "form_" . $forms['table_name'];
            $res = $field->updateField($input['id'], $data);
            if ($res) {
                switch ($types) {
                    case 'varchar':
                        if ($data['default_value']) {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}` VARCHAR({$input['length']}) DEFAULT '({$data["default_value"]})'";
                        } else {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}`  VARCHAR({$input['length']})";
                        }
                        Db::execute($sql);
                        break;
                    case 'int':
                        if ($data['default_value']) {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}` INT(11) DEFAULT '({$data["default_value"]})'";
                        } else {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}` INT(11)";
                        }
                        Db::execute($sql);
                        break;
                    case 'smallint':
                        if ($data['default_value']) {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}` SMALLINT(5) DEFAULT '({$data["default_value"]})'";
                        } else {
                            $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}`  SMALLINT(5)";
                        }
                        Db::execute($sql);
                        break;
                    case 'text':
                        $sql = "ALTER TABLE `{$tablename}` CHANGE COLUMN `{$list}` `{$data['field']}` TEXT ";
                        Db::execute($sql);
                        echo 4;
                        break;
                }
               $this->success(OK, url('field', ['id' => $input['mid']]));
            } else {
                $this->error(FAIL);
            }
        }

        $this->assign('checkbox', $this->fields);
        $diy_field_model = new DiyField();
        $res = $diy_field_model->findField($id);
        $this->assign('res', $res);

        return $this->fetch();
    }

    // 表单管理 - 删除表单字段
    public function fieldDel($id)
    {
        $field= new DiyField();
        $form = new DiyForm();
        $info = $field->findFormField($id);
        $mid  = $info['mid'];
        $data = $form->findForm($mid);
        $tabname = $data['table_name'];
        $res = $field->delField($id);
        if ($res) {
            $tablename = config('database.prefix') . "form_" . $tabname;
            $field = $info['field'];
            Db::execute("ALTER TABLE `{$tablename}` DROP `{$field}`;");
            return ['status'=>1, 'msg'=>OK];
        } else {
            return ['status'=>0, 'msg'=>FAIL];
        }
    }

    // 表单管理 - 读取表记录值
    public function content($id)
    {
        $form_model  = new DiyForm();
        $field_model = new DiyField();
        $table = $form_model->findForm($id);            // 自定义表名称
        $fields= $field_model->selectFormField($id);    // 自定义表的所有字段
        $list  = Db::name('form_' . $table['table_name'])->select();    // 读取自定义表的所有数据
        $this->assign('list', $list);
        $this->assign('fields', $fields);
        return $this->fetch();
    }

    // 表单管理 - 查看某个表单的某个记录 - id是具体哪条记录的，fid是具体哪个表的
    public function contentSee($id, $fid)
    {
        $form_model = new DiyForm();
        $table  = $form_model->findForm($fid);
        $res    = Db::name('form_'.$table['table_name'])->where('id', $id)->find();
        $this->assign('res', $res);
        return $this->fetch();
    }

    // 表单管理 - 删除某个表单的某个记录 - id是具体哪条记录的，fid是具体哪个表的
    public function contentDel($id, $fid)
    {
        $form = new DiyForm();
        $table = $form->findForm($fid);
        $res = Db::name('form_' . $table['table_name'])->where(array('id' => $id))->delete();
        return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
    }

    // 表单管理 - 表单记录导出
    public function contentExport($id)
    {
        //报表数据
        $form_model = new DiyForm();
        $table = $form_model->findForm($id);
        $res = Db::name('form_' . $table['table_name'])->select();
        if (empty($res)) {
            $this->error('暂无表单记录');
        }
        $arr = $res[0];
        $ks = [];
        foreach ($arr as $k => $V) {
            array_push($ks, $k);
        }
        foreach ($res as $key => &$val) {
            $val = array_values($val);
        }
        $res[] = $ks;
        $ReportArr = $res;
        array_unshift($ReportArr, array_pop($ReportArr));
        header("Content-type:application/vnd.ms-excel");
        header("Content-Disposition:attachement;filename=jiducms_" . date("Ymd") . ".xls");
        $ReportContent = '';
        $num1 = count($ReportArr);
        for ($i = 0; $i < $num1; $i++) {
            $num2 = count($ReportArr[$i]);
            for ($j = 0; $j < $num2; $j++) {
                $ReportContent .= '"' . $ReportArr[$i][$j] . '"' . "\t";
            }
            $ReportContent .= "\n";
        }
        $ReportContent = mb_convert_encoding($ReportContent, "gb2312", "utf-8");
        echo $ReportContent;
        exit();
    }
}
