<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\DiyModel;
use app\admin\model\DiyField;
use think\Db;

class Diymode extends Base
{
    public $fields;
    
    public function __construct()
    {
        parent::__construct();
        $get_diy_field  = get_diy_field();
        $this->fields   = $get_diy_field['fields'];     // 自定义表的所有字段类型
        $this->formtype = $get_diy_field['formtype'];   // 自定义表的所有字段类型对应的数据库字段类型
    }

    // 模型管理 - 模型列表
    public function index()
    {
        $model = new DiyModel();
        $field = new DiyField();
        $list  = $model->getAllModel();
        foreach ($list as $k => $v){
            $list[$k]['num'] = $field->getAllFieldCount($list[$k]['id'],1);
        }
        $this->assign('list',$list);
        return $this->fetch();
    }

    // 模型管理 - 添加模型
    public function add()
    {
        if (input('sub')) {
            $input = request()->post();
            $input['type'] = 2;

            $model = new DiyModel();
            $res = $model->insertDiyModel($input);

            if ($res['status'] == 1){
                $sql = "CREATE TABLE `".config('database.prefix')."diy_".$input['table_name']."` (`id` INT(10) PRIMARY KEY NOT NULL AUTO_INCREMENT)";
                Db::execute($sql);
                $this->success('添加成功',"index");
            }else{
                $this->error($res['msg']);
            }
        }

        return $this->fetch();
    }

    // 模型管理 - 编辑模型
    public function edit($id)
    {
        if (input('sub')) {
            if (input('type')) {
                $res = DiyModel::where('id', $id)->update([input('type')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
            } else {
                $input = request()->post();
                $table = DiyModel::get($id);
                $table_name = $table['table_name'];
    
                $model = new DiyModel();
                $res = $model->saveDiyModel($id,$input);
    
                if ($res['status'] == 1){
                    $sql = "ALTER TABLE ".config('database.prefix')."diy_".$table_name." RENAME TO ".config('database.prefix')."diy_".$input['table_name'].";";
                    Db::execute($sql);
                    $this->success('修改成功',"index");
                }else{
                    $this->error($res['msg']);
                }
            }
        }

        $res = DiyModel::get($id);
        $this->assign('res', $res);
        
        return $this->fetch();
    }

    // 模型管理 - 删除模型
    public function del($id)
    {
        $table = DiyModel::get($id);
        $table_name = $table['table_name'];
        try{
            $model = new DiyModel();
            $field = new DiyField();
            $model->delDiyModel($id);
            $field->delAllField($id);
        }catch (\Exception $e){
            return ['status'=>0, 'msg'=>FAIL];
        }
        //删除数据表名
        $sql = "DROP TABLE `".config('database.prefix')."diy_".$table_name."`";
        Db::execute($sql);
        return ['status'=>1, 'msg'=>OK];
    }

    // 模型管理 - 复制模型
    public function copy($id)
    {
        $info = DiyModel::get($id);
        unset($info['id']);

        $table_name = $info['table_name'];
        $name       = $info['name'];
        $rand_eng   = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];
        $rand_size  = array_rand($rand_eng,5);
        $copy_table_name = $rand_eng[$rand_size[0]].$rand_eng[$rand_size[1]].$rand_eng[$rand_size[2]];
        if (strlen($table_name) > 20){
            return ['status'=>0, 'msg'=>'数据表名长度不能超过20'];
        }
        $info['name']       = $name.$copy_table_name;
        $info['table_name'] = $table_name.$copy_table_name;
        $info['type']       = 2;
        $info               = $info->toArray();

        $diy_model = new DiyModel();
        $flag = $diy_model->insertDiyModel($info);
        
        if ($flag['status'] == 1) {
            //复制数据表
            $sql = "CREATE TABLE `".config('database.prefix')."diy_".$info['table_name']."` SELECT * FROM `".config('database.prefix')."diy_".$table_name."` where 0";
            Db::execute($sql);
            //设置主键
            $sql = "ALTER TABLE `".config('database.prefix')."diy_".$info['table_name']."` modify id int AUTO_INCREMENT PRIMARY KEY";
            Db::execute($sql);
            //复制字段管理数据
            $jg = $diy_model->copyDiymodelField($table_name, $info['table_name']);
            if ($jg['code'] != 1) {
                return $jg;
            }else{
                return ['status' => 1, 'msg' => '复制模型成功'];
            }
        } else {
            return ['status'=>0, 'msg'=>$flag['msg']];
        }
    }

    // 模型管理 - 查看每个模型的具体字段
    public function field($id)
    {
        $field_model = new DiyField();
        $model = new DiyModel();
        $res  = $model->getOneDiymodel($id);
        $list = $field_model->selectField($id);
        $fields = $this->fields;
        if ($list) {
            foreach ($list as $k => $v){
                foreach ($fields as $key => $val){
                    if ($list[$k]['field_type'] == $key){
                        $list[$k]['field_type'] = $val;
                    }
                }
                $list[$k]['status'] = $res['type'];
                if ($list[$k]['field_type'] == '------'){
                    $list[$k]['field_type'] = '分组线';
                    $list[$k]['field'] = '------';
                    $list[$k]['name'] = '------';
                    $list[$k]['rands'] = 2;
                }else{
                    $list[$k]['rands'] = 1;
                }
            }
        } else {
            $list = [];
        }
        $this->assign('res',$res);
        $this->assign('list',$list);
        return $this->fetch();
    }

    // 模型管理 - 删除某个模型的某个field
    public function fieldDel($id)
    {
        $field = new DiyField();
        $res = $field->delField($id);
        if ($res){
            return ['status'=>1, 'msg'=>OK];
        }else{
            return ['status'=>-1, 'msg'=>FAIL];
        }
    }

    // 模型管理 - 添加字段
    public function fieldAdd()
    {
        // 过滤敏感词
        $content_field = Db::getTableInfo('jd_content', 'fields');
        $content_field_str = implode(' , ', $content_field);
        $this->assign('content_field', $content_field_str);

        if (input('sub')){
            $diy_field_model = new DiyField();
            $diy_model_model = new DiyModel();
            $data = $input = request()->param();
            if (in_array($input['field'],$content_field)){
                $this->error('有敏感词汇');
            }
            $data['type'] = 1;
            $fields =  $this->fields;       // 获取支持的所有文本类型
            $types  =  $this->formtype;     // 获取文本类型对应的字段类型
            $type   = '';                  // 字段类型
            foreach ($fields as $k => $v){
                if ($k == $input['field_type']){
                    foreach ($types as $key => $val){
                        if ($k == $key){
                            $type = $val;
                        }
                    }
                }
            }

            $selectField = $diy_field_model->selectField($input['mid']);  // 获取本模型所有字段
            if ($selectField) {
                $arr = [];
                foreach ($selectField as $k => $v){
                    array_push($arr, $selectField[$k]['field']);
                }
                if(in_array($data['field'], $arr) == true){
                    return $this->error('字段名称重复');
                }
            }

            $models = $diy_model_model->getOneDiymodel($input['mid']);
            $table_name = config('database.prefix')."diy_".$models['table_name'];   // 获取模型对应表

            $res = $diy_field_model->insertField($data);

            if ($res['status'] == 1){
                switch ($type) {
                    case 'varchar':
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` VARCHAR({$input['length']}) DEFAULT '{$data["default_value"]}'";
                        Db::execute($sql);
                        break;
                    case 'int':
                        $default_value = intval($data["default_value"]);
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` INT(11) UNSIGNED DEFAULT '{$default_value}'";
                        Db::execute($sql);
                        break;
                    case 'smallint':
                        $default_value = intval($data["default_value"]);
                        $sql = "ALTER TABLE `{$table_name}` ADD `{$input['field']}` SMALLINT(5) UNSIGNED DEFAULT '{$default_value}'";
                        Db::execute($sql);
                        break;
                    case 'text':
                        Db::execute("ALTER TABLE `{$table_name}` ADD `{$input['field']}` TEXT");
                        break;
                }
                $this->success('添加字段成功', url('field', ['id'=>$input['mid']]));
            } else {
                $this->error($res['msg']);
            }
        }

        $this->assign('checkbox',$this->fields);    // 字段类型
        return $this->fetch();
    }
    
    // 模型管理 - 编辑字段
    public function fieldEdit($id)
    {
        // 过滤敏感词
        $content_field = Db::getTableInfo('jd_content', 'fields');
        $content_field_str = implode(' , ', $content_field);
        $this->assign('content_field', $content_field_str);

        if (input('sub')) {
            if (input('type')) {
                $res = DiyField::where('id', $id)->update([input('type')=>input('value')]);
				return $res ? ['status'=>1, 'msg'=>'OK'] : ['status'=>0, 'msg'=>FAIL];
            } else {
                $diy_field_model = new DiyField();
                $diy_model_model = new DiyModel();
                $data = $input = request()->param();
                if (in_array($input['field'],$content_field)){
                    $this->error('有敏感词汇');
                }
                $data['type'] = 1;
                $fields =  $this->fields;       // 获取支持的所有文本类型
                $types  =  $this->formtype;     // 获取文本类型对应的字段类型
                $type   = '';                  // 字段类型
                foreach ($fields as $k => $v){
                    if ($k == $input['field_type']){
                        foreach ($types as $key => $val){
                            if ($k == $key){
                                $type = $val;
                            }
                        }
                    }
                }

                $selectField = $diy_field_model->selectField($input['mid']);  // 获取本模型所有字段
                $arr = [];
                foreach ($selectField as $k => $v){
                    array_push($arr,$selectField[$k]['field']);
                }
                $list = '';
                foreach ($selectField as $key => $val){
                    if ($input['id'] == $val['id']){
                        $list = $val['field'];
                    }
                    if ($input['id'] != $val['id'] && $input['field'] == $val['field']){
                        return $this->error('字段名称重复');
                    }
                }

                $models = $diy_model_model->getOneDiymodel($input['mid']);
                $table_name = config('database.prefix')."diy_".$models['table_name'];   // 获取模型对应表

                unset($data['id']);     // 编辑 - 过滤id
                $res = $diy_field_model->updateField($input['id'], $data);

                if ($res['status'] == 1){
                    switch ($type){
                        case 'varchar':
                            if ($data['default_value']){
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}` VARCHAR({$input['length']}) DEFAULT '({$data["default_value"]})'";
                            }else{
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}`  VARCHAR({$input['length']})";
                            }
                            Db::execute($sql);
                            break;
                        case 'int':
                            if ($data['default_value']){
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}` INT(11) DEFAULT '({$data["default_value"]})'";
                            }else{
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}` INT(11)";
                            }
                            Db::execute($sql);
                            break;
                        case 'smallint':
                            if ($data['default_value']){
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}` SMALLINT(5) DEFAULT '({$data["default_value"]})'";
                            }else{
                                $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}`  SMALLINT(5)";
                            }
                            Db::execute($sql);
                            break;
                        case 'text':
                            $sql = "ALTER TABLE `{$table_name}` CHANGE COLUMN `{$list}` `{$data['field']}` TEXT ";
                            Db::execute($sql);
                            break;
                    }
                    $this->success('编辑成功', url('field', ['id'=>$input['mid']]));
                }else{
                    $this->error($res['msg']);
                }
            }
            
        }

        $this->assign('checkbox', $this->fields);
        $field_model = new DiyField();
        $info = $field_model->findField($id);
        $this->assign('res',$info);

        return $this->fetch();
    }


    // 模型管理 - 添加分组线
    public function lineAdd()
    {
        if (input('sub')) {
            $input = request()->param();
            $diy_field_model = new DiyField();
            $box = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x'.'y','z'];
            $size = array_rand($box,3);
            $type = array_rand($box,3);
            $data['length'] = 50;
            $data['mid']    = $input['mid'];
            $data['remark'] = $input['remark'];
            $data['rank']   = $input['rank'];
            $data['type']   = 1;
            $data['name']   = 'jd_'.$box[$size[0]].$box[$size[1]].$box[$size[2]];
            $data['field']  = 'jd_'.$box[$type[0]].$box[$type[1]].$box[$type[2]];
            $data['field_type']     = '------';
            $data['is_not_null']    = 1;
            $res = $diy_field_model->insertField($data);
            if ($res['status'] == 1){
                $this->success('添加分组线成功',  url('field', ['id'=>$input['mid']]));
            }else{
                $this->error('添加分组线失败');
            }
        }
        return $this->fetch();
    }

    // 模型管理 -- 编辑分组线
    public function lineEdit($id)
    {
        if (input('sub')) {
            $input = request()->param();
            $field = new DiyField();
            $data['remark'] = $input['remark'];
            $data['rank']   = $input['rank'];
            $res = $field->updateField($input['id'], $data, 2);
            if ($res['status'] == 1){
                $this->success('编辑成功', url('field', ['id'=>$input['mid']]));
            }else{
                $this->error('编辑失败');
            }
        }

        $field = new DiyField();
        $info = $field->findField($id);
        $this->assign('res',$info);

        return $this->fetch();
    }
}