<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use common\Req;
use think\Db;
use ZipArchive;

class Platform extends Base
{
    public function index()
    {
        $bind_info = Db::name('user')->find();

        $this->assign('link', self::link());
        $this->assign('bind_info', $bind_info);
        $this->assign('hs_auth', self::authQuery());
        $this->assign('version', self::versionQuery());

        return $this->fetch();
    }

    // 通信验证
    public function link()
    {
        $obj = new Req();
        $url = 'Api/link';
        $param = 'jiducms';
        $res = $obj->request_post($url, $param);
        
        return $res ? '通信正常' : '通信异常' ;
    }

    // 绑定云平台账号
    public function bind($phone, $pass)
    {
        $data = request()->post();
        
        if ($data['phone']=='' || $data['pass']=='') {
            return ['status'=>-11, 'msg'=>'手机或密码有误'];
        }

        if (!is_phone($data['phone'])) {
            return ['status'=>-22, 'msg'=>'手机或密码有误'];
        }
        if (!is_pass($data['pass'])) {
            return ['status'=>-33, 'msg'=>'手机或密码有误'];
        }

        $obj = new Req();
        $url = 'Api/userBind';
        $res = $obj->request_post($url, $data);
        $ret = json_decode($res, true);

        // 绑定成功，修改账号信息
        if ($ret['status'] == 1) {
            $res = Db::name('user')->where('id', 1)->update([
                'name'  => $ret['data']['name'],
                'phone' => $ret['data']['phone']
            ]);
            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>'账号已绑定'];
        } else {
            return $ret;
        }
    }


    // 授权认证查询
    public function authQuery()
    {
        $user   = Db::name('user')->find();
        $domain = $_SERVER['HTTP_HOST'];

        $param = [
            'phone' => $user['phone'],
            'domain'=> $domain
        ];

        $obj = new Req();
        $url = 'Api/authQuery';
        $res = $obj->request_post($url, $param);
        $ret = json_decode($res, true);

        if ($ret['status'] == 1) {
            return '已授权';
        } else {
            return '未授权';
        }
    }

    // 版本查询
    public function versionQuery()
    {
        return file_get_contents('version.txt');
    }

    // 检查版本是否最新
    public function upgrade()
    {
        $param['version'] = self::versionQuery();

        $obj = new Req();
        $url = 'Api/upgrade';
        $res = $obj->request_post($url, $param);
        $ret = json_decode($res, true);
        $this->assign('ret', $ret);
        return $this->fetch();
    }

    //下载最新版本
    public function download($version = '')
    {
        $authorization = self::authQuery();
        if($authorization == '未授权'){
            return ['status' => -3, 'msg' => '未授权，请使用正常渠道购买授权！'];
        }
        if (!request()->isPost() || empty($version)) {
            return ['status' => -1, 'msg' => '参数传递错误！'];
        }
        //远程压缩包地址
        $url = 'http://upgrade.jiducms.com/'.$version.".zip";
        //保存到本地地址
        $path = ROOT_PATH.$version.".zip";
        //下载压缩包
        $ch = curl_init($url);
        $fp = fopen($path, "wb");
        curl_setopt($ch, CURLOPT_FILE, $fp);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        $res=curl_exec($ch);
        curl_close($ch);
        fclose($fp);
        if($res){
            return ['status'=>1,'msg'=>$version.".zip"];
        }else{
            return ['status'=>-2, 'msg'=>'升级包获取失败！'];
        }
    }

    //安装升级包
    public function install($file = '', $version = '')
    {
        if (!request()->isPost() || empty($version)) {
            return ['status' => -1, 'msg' => '参数传递错误！'];
        }
        $file = ROOT_PATH.$file;
        if (!file_exists($file)) {
            $this->clearCache($file);
            return ['status' => -2, 'msg' => $version.' 升级包异常，请重新升级！'];
        }
        $zip = new \ZipArchive;
        $res = $zip->open($file);
        $extractTo = ROOT_PATH;
        if ($res === TRUE) {
            //解压缩到$extractTo指定的文件夹
            $zip->extractTo($extractTo);
            $zip->close();
            unlink($file);
            $data = $version;
            $numbytes = file_put_contents('version.txt', $data); //如果文件不存在创建文件，并写入内容
            if(!$numbytes) {
                return ['status'=>-3,'msg'=>'版本写入写入失败！'];
            }
            return ['status'=>1,'msg'=>'安装更新成功！'];
        } else {
            return ['status'=>-4,'msg'=>'安装更新失败！'];
        }
    }
    
    // 模板更新
    public function renewtpl()
    {
        $bind_info = Db::name('user')->find();
        $param['phone'] = $bind_info['phone'];
        $obj = new Req();
        $url = 'Api/renewtpl';
        $res = $obj->request_post($url, $param);
        $result = json_decode($res, true);
        $this->assign('result', $result);
        return $this->fetch();
    }
}