<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | DREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\System as SystemModel;

use app\admin\model\Config;

class System extends Base
{
  public function upload()
  {
      $system = new SystemModel();
      $upload_file_size = $system->upload_configure('upload_file_size');//上传文件大小
      $upload_file_ext = $system->upload_configure('upload_file_ext');//上传文件格式
      $upload_image_size = $system->upload_configure('upload_image_size');//上传图片大小
      $upload_image_ext = $system->upload_configure('upload_image_ext');//上传图片格式
      $upload_watermark = $system->upload_configure('upload_watermark');//水印设置
      $watermark = explode('%',$upload_watermark['val']);
      $count = count($watermark);
      if ($count == 1){//没有水印
          $this->assign('watermark',null);
          $this->assign('imgs',null);
      }else if ($count == 3){//图片水印
          $this->assign('watermark',null);
          $this->assign('imgs',$watermark);
      }else{//文字水印
          $this->assign('watermark',$watermark);
          $this->assign('imgs',null);
      }
      $this->assign('upload_file_size',$upload_file_size);
      $this->assign('upload_file_ext',$upload_file_ext);
      $this->assign('upload_image_size',$upload_image_size);
      $this->assign('upload_image_ext',$upload_image_ext);
      $this->assign('show_type',$upload_watermark['show_type']);
      return $this->fetch();
  }
  
  public function text(){
  	if(extension_loaded('gd')){
		echo '你可以使用gd库';
		foreach (gd_info() as $k => $v){
			echo "$k-$v<br>";
		}
	}else {
		echo  '您未开启gd库';
	}
  }

  public function update_system()
  {
      $system = new SystemModel();
      $data = $this->request->param();
      $array = [];
      $status = $data['type'];//0：不加水印；1：文字水印；2：图片水印
      if ($status == 0){///不加水印
          $res = ['show_type'=>0,'val'=>''];
      }else if ($status == 1){///文字水印
          if(isset($data['watermark_position']) == false){
              $data['watermark_position'] = '';
          }
          foreach ($data as $k => $v){
              if (empty($v)){
                  unset($data[$k]);
              }
              switch ($k){
                  case 'watermark_position':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'watermark_word':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'watermark_size':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'watermark_pixel':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'watermark_color':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
              }
          }
          $str = '';
          for ($i=0;$i<count($array);$i++){
              if ($i==0){
                  $str.=$array[$i];
              }else{
                  if ($i == 2 && $array[$i] > 18){
                      $this->error('文字水印像素过大，最大为18像素');
                  }
                  $str.='%'.$array[$i];
              }
          }
          $res = ['val'=>$str,'show_type'=>1];
      }else if ($status == 2){///图片水印
          if(isset($data['watermark_positions']) == false){
              $data['watermark_positions'] = '';
          }
          foreach ($data as $k => $v){
              if (empty($v)){
                  unset($data[$k]);
              }
              switch ($k){
                  case 'watermark_positions':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'content2':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
                  case 'transparency':
                      $data[$k] = empty($data[$k])?0:$data[$k];
                      array_push($array,$data[$k]);
                      unset($data[$k]);
                      break;
              }
              $str = '';
              for ($i=0;$i<count($array);$i++){
                  if ($i==0){
                      $str.=$array[$i];
                  }else{
                      $str.='%'.$array[$i];
                  }
              }
              $res = ['val'=>$str,'show_type'=>2];
          }
      }
      $input = $data;
      foreach ($input as $k => $v){
          if ($k != 'upload_file_size' && $k != 'upload_file_ext' && $k != 'upload_image_size' && $k != 'upload_image_ext'){
              unset($input[$k]);
          }
      }
      $type =  $system->insert_configure('upload_watermark' ,$res);
      if ($type){
          foreach ($input as $key => $val){
              $arr = ['val'=>$val];
              try{
                  $system->insert_configure($key ,$arr);
              }catch (\Exception $e){
                  return $this->error('修改上传配置失败');
              }
          }
      }else{
          return $this->error('修改上传配置失败');
      }

      $this->success('修改上传配置成功','upload');
  }

  public function uploadImg()//水印图片的上传
  {
      $config_model = new Config();
      $ext  = $config_model->getValue('upload_image_ext');
      $size = $config_model->getValue('upload_image_size');

      $file = request()->file('img');
      if (!isset($file)) {
          return ['status'=>-1, 'msg'=>'请选择上传的文件'];
      }

      $info = $file->validate(['ext'=>$ext, 'size'=>$size*1024])->move(ROOT_PATH.'public'.DS.'uploads');
      if (!$info) {
          return ['status'=>-1, 'msg'=>'图片格式只能是'.$ext.'，图片大小不超过'.$size.'KB'];
      }        

      $img = '/uploads/'.date('Ymd').'/'.$info->getFilename();    // 图片路径
      return ['status'=>1, 'msg'=>OK, 'data'=>$img];
  }
}