<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Config;
use common\Dir;
use think\Db;

class Upload extends Base
{
    // 单图片上传
    public function imgSingle($is_water=0)
    {
        $config_model = new Config();
        $ext  = $config_model->getValue('upload_image_ext');
        $size = $config_model->getValue('upload_image_size');

        $file = request()->file('img');
        if (!isset($file)) {
            $file = request()->file('oneImg');
            if (!isset($file)) {
                $file = request()->file('allImg');
                if (!isset($file)) {
                    return ['status'=>-1, 'msg'=>'请选择上传的文件'];
                }
            }
        }
        if (!isset($file)) {
            return ['status'=>-1, 'msg'=>'请选择上传的文件'];
        }

        $info = $file->validate(['ext'=>$ext, 'size'=>$size*1024])->move(ROOT_PATH.'public'.DS.'uploads');
        if (!$info) {
            return ['status'=>-1, 'msg'=>'图片格式只能是'.$ext.'，图片大小不超过'.$size.'KB'];
        }

        $img = '/uploads/'.date('Ymd').'/'.$info->getFilename();    // 图片路径

        $imgs = $_SERVER['DOCUMENT_ROOT'].$img;
        $watermark = Db::name('config')->where(['tag'=>'upload_watermark'])->find();

        // dump($watermark);
        $image = explode('%',$watermark['val']);
        //dump($image);die;
        if ($is_water == 1) {

        } else {
            if ($watermark['show_type'] == 1){

            }else if ($watermark['show_type'] == 2){
                $text = $this->imageWaterMark($imgs,$image[0],null,$image[1],$image[2],'#'.$image[4],$image[2]);
            }else if ($watermark['show_type'] == 3){
                $text = $this->imageWaterMark($imgs,$image[0],$_SERVER['DOCUMENT_ROOT'].$image[1]);
            }
        }
        if (isset($text)){
            return ['status'=>0, 'msg'=>$text, 'data'=>$img];
        }else{
            return ['status'=>1, 'msg'=>OK, 'data'=>$img];
        }

    }

    // 附件上传
    public function fileSingle()
    {
        $config_model = new Config();
        $ext  = $config_model->getValue('upload_file_ext');
        $size = $config_model->getValue('upload_file_size');

        $file = request()->file('file');
        if (!isset($file)) {
            return ['status'=>-1, 'msg'=>'请选择上传文件'];
        }

        $info = $file->validate(['ext'=>$ext, 'size'=>$size*1024])->move(ROOT_PATH.'public'.DS.'files');
        if (!$info) {
            return ['status'=>-1, 'msg'=>'文件格式只能是'.$ext.'，文件大小不超过'.$size.'KB'];
        }

        $oneFile = '/files/'.date('Ymd').'/'.$info->getFilename();    // 路径

        return ['status'=>1, 'msg'=>OK, 'data'=>$oneFile];
    }

    // 视频上传
    public function videoSingle()
    {
        $config_model = new Config();
        $ext  = $config_model->getValue('upload_video_ext');
        $size = $config_model->getValue('upload_video_size');

        $file = request()->file('img');
        if (!isset($file)) {
            return ['status'=>-1, 'msg'=>'请选择上传视频文件'];
        }

        $info = $file->validate(['ext'=>$ext, 'size'=>$size*1024])->move(ROOT_PATH.'public'.DS.'files');
        if (!$info) {
            return ['status'=>-1, 'msg'=>'文件格式只能是'.$ext.'，文件大小不超过'.$size.'KB'];
        }

        $url = '/files/'.date('Ymd').'/'.$info->getFilename();    // 路径

        return ['status'=>1, 'msg'=>OK, 'data'=>$url];
    }

    // 音频上传
    public function audioSingle()
    {
        $config_model = new Config();
        $ext  = $config_model->getValue('upload_audio_ext');
        $size = $config_model->getValue('upload_audio_size');

        $file = request()->file('img');
        if (!isset($file)) {
            return ['status'=>-1, 'msg'=>'请选择上传音频文件'];
        }

        $info = $file->validate(['ext'=>$ext, 'size'=>$size*1024])->move(ROOT_PATH.'public'.DS.'files');
        if (!$info) {
            return ['status'=>-1, 'msg'=>'文件格式只能是'.$ext.'，文件大小不超过'.$size.'KB'];
        }

        $url = '/files/'.date('Ymd').'/'.$info->getFilename();    // 路径

        return ['status'=>1, 'msg'=>OK, 'data'=>$url];
    }


    // 添加图片水印
    public function imageWaterMark($groundImage,$waterPos=0,$waterImage="",$waterText="",$textFont='',$textColor="#FF0000",$angle='')
    {
        $isWaterImage = FALSE;
        $formatMsg = "暂不支持该文件格式，请用图片处理软件将图片转换为GIF、JPG、PNG格式。";
        // 读取水印文件
        // $waterImage   水印图片
        if(!empty($waterImage) && file_exists($waterImage))
        {
            $isWaterImage = TRUE;
            $water_info = getimagesize($waterImage);
            $water_w    = $water_info[0];   // 取得水印图片的宽
            $water_h    = $water_info[1];   // 取得水印图片的高
            switch($water_info[2]) {    // 取得水印图片的格式
                case 1:
                    $water_im = imagecreatefromgif($waterImage);
                    break;
                case 2:
                    $water_im = imagecreatefromjpeg($waterImage);
                    break;
                case 3:
                    $water_im = imagecreatefrompng($waterImage);
                    break;
                default:
                    return $formatMsg;
            }
        }
        // 读取背景图片
        if(!empty($groundImage) && file_exists($groundImage))
        {
            $ground_info = getimagesize($groundImage);
            $ground_w    = $ground_info[0]; // 取得背景图片的宽
            $ground_h    = $ground_info[1]; // 取得背景图片的高
            switch($ground_info[2]) {   // 取得背景图片的格式
                case 1:
                    $ground_im = imagecreatefromgif($groundImage);
                    break;
                case 2:
                    $ground_im = imagecreatefromjpeg($groundImage);
                    break;
                case 3:
                    $ground_im = imagecreatefrompng($groundImage);
                    break;
                default:
                    return $formatMsg;
            }
        } else {
            return "需要加水印的图片不存在！";
        }
        // 水印位置
        if($isWaterImage) { // 图片水印
            $w = $water_w;
            $h = $water_h;
            $label = "图片的";
        }
        else {  // 文字水印
            $temp = imagettfbbox(ceil($textFont*2.5),0,$_SERVER['DOCUMENT_ROOT']."/static/plug/ttf/small.ttf",$waterText);  // 取得使用 TrueType 字体的文本的范围
            $w = $temp[2] - $temp[6];
            $h = $temp[3] - $temp[7];
            unset($temp);
            $label = "文字区域";
        }
        if( ($ground_w<$w) || ($ground_h<$h) )
        {
            return  "需要加水印的图片的长度或宽度比水印".$label."还小，无法生成水印！";
        }
        switch($waterPos) {
            case 0: // 随机
                $posX = rand(0,($ground_w - $w));
                $posY = rand(0,($ground_h - $h));
                break;
            case 1: // 1为顶端居左
                $posX = 0;
                $posY = 0;
                break;
            case 2: // 2为顶端居中
                $posX = ($ground_w - $w) / 2;
                $posY = 0;
                break;
            case 3: // 3为顶端居右
                $posX = $ground_w - $w;
                $posY = 0;
                break;
            case 4: //4为中部居左
                $posX = 0;
                $posY = ($ground_h - $h) / 2;
                break;
            case 5: // 5为中部居中
                $posX = ($ground_w - $w) / 2;
                $posY = ($ground_h - $h) / 2;
                break;
            case 6: // 6为中部居右
                $posX = $ground_w - $w;
                $posY = ($ground_h - $h) / 2;
                break;
            case 7: // 7为底端居左
                $posX = 0;
                $posY = $ground_h - $h;
                break;
            case 8: // 8为底端居中
                $posX = ($ground_w - $w) / 2;
                $posY = $ground_h - $h;
                break;
            case 9: // 9为底端居右
                $posX = $ground_w - $w;
                $posY = $ground_h - $h;
                break;
            default:    // 随机
                $posX = rand(0,($ground_w - $w));
                $posY = rand(0,($ground_h - $h));
                break;
        }
        // 设定图像的混色模式
        imagealphablending($ground_im, true);
        if($isWaterImage) { // 图片水印
            imagecopy($ground_im, $water_im, $posX, $posY, 0, 0, $water_w,$water_h);    // 拷贝水印到目标文件
        }
        else {  // 文字水印
            if( !empty($textColor) && (strlen($textColor)==7) ) {
                $R = hexdec(substr($textColor,1,2));
                $G = hexdec(substr($textColor,3,2));
                $B = hexdec(substr($textColor,5));
            } else {
                return "水印文字颜色格式不正确！";
            }
            $pink = ImageColorAllocate($ground_im,$R,$G,$B);
            imageTtfText($ground_im,ceil($textFont*2.5),$angle,$posX, $posY,$pink,$_SERVER['DOCUMENT_ROOT']."/static/plug/ttf/small.ttf",$waterText);
        }
        // 生成水印后的图片
        @unlink($groundImage);
        switch($ground_info[2]) {   //取得背景图片的格式
            case 1:
                imagegif($ground_im,$groundImage);
                break;
            case 2:
                imagejpeg($ground_im,$groundImage);
                break;
            case 3:
                imagepng($ground_im,$groundImage);
                break;
            default:
                return '上传图片不符合固定格式';
        }
        // 释放内存
        if(isset($water_info)) unset($water_info);
        if(isset($water_im)) imagedestroy($water_im);
        unset($ground_info);
        imagedestroy($ground_im);
    }

    // 图片文件 管理
    public function fileMag($spath='')
    {
        $spath = input('spath');

        $base_path = '/uploads';
        $encodeflag = input('encodeflag', 0, 'intval');
        if ($encodeflag) {
            $spath = base64_decode($spath);
        }
        $spath = str_replace('.', '', ltrim($spath,$base_path));
        $path = $base_path . '/'. $spath;

        $dirlist = new Dir('.'.$path);
        $list = $dirlist->toArray();

        for ($i=0; $i < count($list); $i++) {
            $list[$i]['isImg'] = 0;
            if ($list[$i]['isFile']) {
                $url = rtrim($path,'/') . '/'. $list[$i]['filename'];
                $ext = explode('.', $list[$i]['filename']);
                $ext = end($ext);
                if (in_array($ext, explode(',', 'rar,zip,pdf,doc,docx,xls,xlsx,ttf'))) {
                    $list[$i]['isImg'] = 1;
                }
            } else {
                $url = url('upload/fileMag', array(
                        'spath'     => base64_encode(rtrim($path,'/') . '/'. $list[$i]['filename']),
                        'encodeflag'=> 1 )
                );
            }
            $list[$i]['url'] = $url;
            $list[$i]['size'] = get_byte($list[$i]['size']);
        }

        $last_names = array_column($list, 'filename');
        array_multisort($last_names, SORT_DESC, $list);

        $parentpath = substr($path, 0, strrpos($path, '/'));

        $data = [
            'purl'=>  url('upload/fileMag', array('spath'=> base64_encode($parentpath),'encodeflag' => 1)),
            'infolist'=> $list,
        ];

        return ['status'=>1, 'msg'=>OK, 'data'=>$data];
    }
}