<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;

class Admin extends Model
{
    protected $name = 'admin';

    // 添加管理员
    public function insertAdmin($param)
    {
        if ($param['role_id'] == '') {
            return ['status'=>-1, 'msg'=>'请选择管理员角色'];
        }
        if (!is_name($param['name'])) {
            return ['status'=>-2, 'msg'=>'账号格式有误'];
        }
        if (!is_pass($param['pass'])) {
            return ['status'=>-3, 'msg'=>'密码格式有误'];
        }

        $find_admin = $this->where('name', $param['name'])->find();
        if ($find_admin) {
            return ['status'=>-4, 'msg'=>'管理员账号已存在'];
        }

        $param['pass'] = password_hash($param['pass'], PASSWORD_DEFAULT);
        $res = $this->insert($param);

        return $res ? ['status'=>1, 'msg'=>OK] :['status'=>0, 'msg'=>FAIL];
    }

    // 编辑管理员
    public function updateAdmin($param, $id)
    {
        if ($param['role_id'] == '') {
            return ['status'=>-1, 'msg'=>'请选择管理员角色'];
        }
        if (!is_name($param['name'])) {
            return ['status'=>-2, 'msg'=>'账号格式有误'];
        }
        if ($param['pass'] != '') {
            if (!is_pass($param['pass'])) {
                return ['status'=>-3, 'msg'=>'密码格式有误'];
            }
            $param['pass'] = password_hash($param['pass'], PASSWORD_DEFAULT);
        } else {
            unset($param['pass']);
        }

        $find_admin = $this->where('id', '<>', $id)->where('name', $param['name'])->find();
        if ($find_admin) {
            return ['status'=>-4, 'msg'=>'管理员账号已存在'];
        }

        $res = $this->where('id', $id)->update($param);

        return $res ? ['status'=>1, 'msg'=>OK] :['status'=>0, 'msg'=>FAIL];
    }
}