<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Db;
use think\Model;
use app\admin\model\DiyModel;

class Content extends Model
{
	protected $name = 'content';

	public function insertContent($param)
	{
        try {
            if ($param['title'] == '') {
                return ['status'=>-1, 'msg'=>'标题不能为空'];
            }

            // 先找到对应模型表
            $model = DiyModel::get($param['mid']);

            foreach ($param as $key => $val) {
                if (is_array($val)) {
                    $val = implode(',', $val);
                }
                $param[$key] = $val;
            }
            $param['id'] = null;    // 防止数据为空时，没有添加到第三方表中

            // 找到模型操作的表： "diy_".$model['table_name']
            $the_id = Db::name('diy_'.$model['table_name'])->insertGetId($param);

            // 再添加内容
            $content_data = $param;
            $content_data['the_id'] = $the_id;
            $content_data['time']   = date('Y-m-d H:i:s');
            $content_data['tag']    = implode(',', explode(' ', $param['tag']));
            $res = $this->insert($content_data);

            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>$this->getError()];
        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>$e->getMessage()];
        }
	}

	public function getAllContent()
    {
        $item = $this->select();
        $product = isset($item)?$item->toArray():array();
        return $product;
    }

    public function getOneContent($id)
    {
        $info = $this->where('id', $id)->find()->toArray();
        $table_name = Db::name('auth_model')->where('id', $info['mid'])->value('table_name');
        $info_ = Db::name('diy_'.$table_name)->where('id', $info['the_id'])->find();
        if ($info_) {
            return array_merge($info, $info_);
        } else {
            return $info;
        }
    }
    
    // 1. 修改内容表，2 修改自定义表
    public function updateContent($param, $id)
    {
        try {
            $content_data = $param;
            foreach ($param as $key => $val) {
                if (is_array($val)) {
                    $val = implode(',', $val);
                }
                $param[$key] = $val;
            }
            $content_data['edit_time']  = date('Y-m-d H:i:s');
            $content_data['tag']        = implode(',', explode(' ', $param['tag']));

            $res = $this->where('id', $id)->update($content_data);

            $info = $this->where('id', $id)->find()->toArray();
            $diy_table_name = Db::name('auth_model')->where('id', $info['mid'])->value('table_name');
            $res_ = Db::name('diy_'.$diy_table_name)->where('id', $info['the_id'])->update($param);

            if ($res === false || $res_ === false) {
                return ['status'=>-1, 'msg'=>'信息未修改或者修改失败'];
            } else {
                return ['status'=>1, 'msg'=>OK, 'cid'=>$info['cid']];
            }
        } catch (\PDOException $e) {
            return ['status'=>-2, 'msg'=>$this->getMessage()];
        }
    }

    // 删除内容，包括第三张表的数据
    public function deleteContent($id)
    {
        try {
            $info = $this->where('id', 'in', $id)->select();
            if ($info) {
                $this->where('id', 'in', $id)->delete();   // 删除内容表数据

                $diymodel_model = new DiyModel;
                foreach ($info as $k => $v) {
                    $table_name = $diymodel_model->where('id', $v['mid'])->value('table_name');
                    if ($table_name) {
                        Db::name('diy_'.$table_name)->where('id', $v['the_id'])->delete();   // 如果第三张表存在，删除第三张表里面的数据
                    }
                }
            }
            return ['status'=>1, 'msg'=>OK];
        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>$e->getMessage()];
        }
    }

    // 弃用
    public function deleteOneContent($id)
    {
        try {
            $info = $this->where('id', $id)->find()->toArray();     // 获取当前内容信息
            $table_name = Db::name('auth_model')->where('id', $info['mid'])->value('table_name');

            $del = $this->where('id', $id)->delete();
            $del_= Db::name('diy_'.$table_name)->where('id', $info['the_id'])->delete();

            return $del && $del_ ? ['status'=>1, 'msg'=>OK] : ['status'=>-1, 'msg'=>$this->getError()];
        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>$e->getMessage()];
        }
    }
}