<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;
use think\Db;

class DiyForm extends Model
{
    protected $name = 'auth_form';

    public function selectAllForm()
    {
        $item = $this->order('rank asc')->select();
        $product = empty($item)?array():$item->toArray();
        return $product;
    }

    // 添加表单
    public function insertForm($param)
    {
        try {
            if ($param['name'] == '' || $param['table_name'] == '') {
                return ['status'=>-1, 'msg'=>'必填项不能为空'];
            }
            $find_form = $this->get(['name'=>$param['name']]);
            if ($find_form) {
                return ['status'=>-2, 'msg'=>'表单已存在'];
            }
            $find_form = $this->get(['table_name'=>$param['table_name']]);
            if ($find_form) {
                return ['status'=>-3, 'msg'=>'表名字已存在'];
            }

            $res = $this->allowField(true)->save($param);
            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];

        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }

    public function findForm($id)
    {
        $item = $this->where(['id'=>$id])->find();
        $res  = empty($item)?array():$item->toArray();
        return $res;
    }

    // 编辑表单
    public function updateForm($id, $param)
    {
        try {
            if ($param['name'] == '' || $param['table_name'] == '') {
                return ['status'=>-1, 'msg'=>'必填项不能为空'];
            }
            $find_form = $this->where('id', '<>', $id)->where('name', $param['name'])->find();
            if ($find_form) {
                return ['status'=>-2, 'msg'=>'表单已存在'];
            }
            $find_form = $this->where('id', '<>', $id)->where('table_name', $param['table_name'])->find();
            if ($find_form) {
                return ['status'=>-3, 'msg'=>'表名字已存在'];
            }

            $res = $this->allowField(true)->save($param, ['id'=>$id]);
            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];

        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }

    public function copyDiymodelField($ytabname, $ntabname)
    {
        try{
            $yid = $this->where('table_name', $ytabname)->find();
            $nid = $this->where('table_name', $ntabname)->find();
            $fieldlist = Db::name('auth_field')->where(['mid'=>$yid['id'],'type'=>2])->select();
            foreach ($fieldlist as $k => $v) {
                unset($fieldlist[$k]['id']);
                $fieldlist[$k]['mid'] = $nid['id'];
            }
            Db::name('auth_field')->insertAll($fieldlist);
            return ['code' => 1, 'data' => '', 'msg' => ''];
        }catch(\Exception $e){
            return ['code' => 0, 'data' => '', 'msg' => $e->getMessage()];
        }
    }

    public function delForm($id)
    {
        return $this->where(['id'=>$id])->delete();
    }
}