<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;
use think\Db;

class DiyModel extends Model
{
    protected $name = 'auth_model';

    public function getAllModel()
    {
        return $this->order('rank asc')->select()->toArray();
    }

    public function getOneDiymodel($id)
    {
        $item = $this->where(['id'=>$id])->find();
        $product = empty($item)?array():$item->toArray();
        return $product;
    }

    public function insertDiyModel($param)
    {
        try {
            if ($param['name'] == '' || $param['table_name'] == '') {
                return ['status'=>-1, 'msg'=>'必填项不能为空'];
            }
            $find_model = $this->get(['name'=>$param['name']]);
            if ($find_model) {
                return ['status'=>-2, 'msg'=>'模型已存在'];
            }
            $find_model = $this->get(['table_name'=>$param['table_name']]);
            if ($find_model) {
                return ['status'=>-3, 'msg'=>'表名字已存在'];
            }

            $res = $this->allowField(false)->save($param);
            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];

        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }

    public function saveDiyModel($id,$param)
    {
        try {
            if ($param['name'] == '' || $param['table_name'] == '') {
                return ['status'=>-1, 'msg'=>'必填项不能为空'];
            }
            $find_model = $this->where('id', '<>', $id)->where('name', $param['name'])->find();
            if ($find_model) {
                return ['status'=>-2, 'msg'=>'模型已存在'];
            }
            $find_model = $this->where('id', '<>', $id)->where('table_name', $param['table_name'])->find();
            if ($find_model) {
                return ['status'=>-3, 'msg'=>'表名字已存在'];
            }

            $res = $this->allowField(false)->save($param, ['id'=>$id]);
            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];

        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }

    public function delDiyModel($id)
    {
        return $this->where(array('id'=>$id))->delete();
    }

    public function copyDiymodelField($ytabname, $ntabname)
    {
        try{
            $yid = $this->where('table_name', $ytabname)->find();
            $nid = $this->where('table_name', $ntabname)->find();
            $db = Db::name('auth_field');
            $fieldlist = $db->where(['mid'=>$yid['id'],'type'=>1])->select();
            foreach ($fieldlist as $k => $v) {
                unset($fieldlist[$k]['id']);
                $fieldlist[$k]['mid'] = $nid['id'];
            }
            $db->insertAll($fieldlist);
            return ['code' => 1, 'data' => '', 'msg' => ''];
        }catch(\Exception $e){
            return ['code' => 0, 'data' => '', 'msg' => $e->getMessage()];
        }
    }
}