<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | DREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
// 应用公共文件

use think\Db;

define('OK', '操作成功');
define('FAIL', '系统繁忙');

/*
 *	验证用户名 4-18位数字或字母
 * */
function is_name($str)
{
    return preg_match("/^[A-Za-z0-9]{4,18}$/", $str) ? true : false ;
}


/*
 *	验证密码 6-18位数字或字母
 * */
function is_pass($str)
{
    return preg_match("/^[A-Za-z0-9]{6,18}$/", $str) ? true : false ;
}


/*
 *	验证手机号
 * */
function is_phone($str)
{
    return preg_match("/^1[3456789]{1}\d{9}$/", $str) ? true : false ;
}


/*
 *	获取用户IP
 */
function get_ip()
{
	return $_SERVER['SERVER_ADDR'];
}


/*
 *	记录用户操作日志
 */
function get_log($id, $name, $info, $status)
{	
	$data = [
        'admin_id'  => $id,
        'admin_name'=> $name,
        'info'      => $info,
        'ip'        => get_ip(),
        'status'    => $status,
        'time'      => date('Y-m-d H:i:s')
    ];
    Db::name('admin_log')->insert($data);
}

/*
 * 功能：获取一个文件夹地下的所有文件（递归）
*/
function getAllDir($dir)
{
	$files = array();
    foreach (glob($dir . DS.'*') as $file) {
        if (is_dir($file)) {
            $files = array_merge($files, getAllDir($file));
        } else {
            $files[] = $file;
        }
    }
    return $files;
}

/*替换数据表中的特殊字符*/

function gettableval($table)
{
    //创建DB对象
    $db = Db::connect();
    $valstr = "";
    $result = $db->query("SELECT * FROM `{$table}`");
    foreach ($result as $row) {
        $row = array_map('addslashes', $row);
        $valstr .= str_replace(array("\r","\n"),array('\r','\n'),implode("', '", $row));
    }
    return $valstr;
}


/**
 *  功能：计算文件大小
 *  @param int $bytes
 *  @return string 转换后的字符串
 */
function get_byte($bytes)
{
    if (empty($bytes)) {
        return '--';
    }
    $sizetext = array(" B", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
    return round($bytes / pow(1024, ($i = floor(log($bytes, 1024)))), 2) . $sizetext[$i];
}

/**
 *  读取固定格式的文件列表
 *  @param int $dir_path 文件夹路径, $pattern文件名限定
 *  @return arr 转换后的字符串
 */
function get_file_list($dir_path, $pattern = '*')
{
    $files = [];

    $list = glob($dir_path . $pattern);
    if ($list) {
        foreach ($list as $i => $file) {
            $files[] = basename($file);
        }
    }
    if (empty($files)) {
        $files = [];
    }

    return $files;
}


/**
 *  菜单样式处理
 *  @param int $cate 菜单数组, $pattern文件名限定
 *  @return arr 转换后的字符串
 */
function rule($cate, $lefthtml = '— — ', $pid = 0, $lvl = 0, $leftpin = 0)
{
    $arr = array();
    foreach ($cate as $v) {
        if ($v['pid'] == $pid) {
            $v['lvl'] = $lvl + 1;
            $v['leftpin'] = $leftpin + $lvl * 20; //左边距
            $v['lefthtml'] = str_repeat($lefthtml, $lvl);
            $v['leftkong'] = str_repeat('&nbsp;&nbsp;&nbsp;&nbsp;', $lvl);
            $arr[] = $v;
            $arr = array_merge($arr, rule($cate, $lefthtml, $v['id'], $lvl + 1, $leftpin + 15));
        }
    }
    return $arr;
}

/**
 *  获取拼音信息
 *
 * @access    public
 * @param     string  $str  字符串
 * @param     int  $ishead  是否为首字母
 * @param     int  $isclose  解析后是否释放资源T
 * @return    string
 */
function get_pinyin($str, $ishead = 0, $isclose = 1)
{
    $pinyins = array();
    $restr = '';
    $str = trim($str);
    $slen = strlen($str);

    if ($slen < 2) {
        return $str;
    }
    if (count($pinyins) == 0) {
        $fp = fopen('./static/pinyin.dat', 'r');
        if (false == $fp) {
            return '';
        }
        while (!feof($fp)) {
            $line = trim(fgets($fp));
            $pinyins[$line[0] . $line[1]] = substr($line, 3, strlen($line) - 3);
        }
        fclose($fp);
    }

    for ($i = 0; $i < $slen; $i++) {
        if (ord($str[$i]) > 0x80) {
            $c = $str[$i] . $str[$i + 1];
            $i++;
            if (isset($pinyins[$c])) {
                if ($ishead == 0) {
                    $restr .= $pinyins[$c];
                } else {
                    $restr .= $pinyins[$c][0];
                }
            } else {
                $restr .= "";
            }
        } else if (preg_match("/[a-z0-9]/i", $str[$i])) {
            $restr .= $str[$i];
        } else {
            $restr .= "";
        }
    }
    if ($isclose == 0) {
        unset($pinyins);
    }
    return $restr;
}


/*
 *  自定义模型的字段类型及对应模型元素类型
 * */
function get_diy_field()
{
    $fields = ['text' => '单行文本', 'textarea' => '多行文本', 'seditor' => '简约编辑器', 'editor' => '富文本编辑器', 'file' => '附件', 'image' => '单图上传','images' => '多图上传', 'datetime' => '日期和时间', 'number' => '数字', 'radio' => ' 单选按钮', 'checkbox' => '复选框', 'select' => '下拉框', 'video'=>'视频', 'audio'=>'音频'];
    $formtype = [
        'text'      => 'varchar',
        'textarea'  => 'text',
        'seditor'   => 'text',
        'editor'    => 'text',
        'file'      => 'varchar',
        'image'     => 'varchar',
        'images'    => 'text',
        'datetime'  => 'varchar',
        'radio'     => 'text',
        'checkbox'  => 'text',
        'number'    => 'int',
        'select'    => 'text',
        'video'     => 'varchar',
        'audio'     => 'varchar'
    ];
    return ['fields'=>$fields, 'formtype'=>$formtype];
}

/*
 *  自定义表单的字段类型及对应表单元素类型
 * */
function get_diy_form()
{
    $fields = ['text' => '单行文本','number' => '数字', 'textarea' => '多行文本','radio' => '单选按钮', 'checkbox' => '复选框', 'select' => '下拉框'];
    $formtype = [
        'text'      => 'varchar',
        'textarea'  => 'text',
        'radio'     => 'text',
        'checkbox'  => 'text',
        'number'    => 'int',
        'select'    => 'text'
    ];
    return ['fields'=>$fields, 'formtype'=>$formtype];
}

/*
 * 判断用户使用什么登陆的（pc or mobile）
 * */
function isMobile()
{
    // 如果有HTTP_X_WAP_PROFILE则一定是移动设备
	 if (isset($_SERVER['HTTP_X_WAP_PROFILE'])) {
        return true;
    }
    //此条摘自TPM智能切换模板引擎，适合TPM开发
    if (isset($_SERVER['HTTP_CLIENT']) && 'PhoneClient' == $_SERVER['HTTP_CLIENT']) {
        return true;
    }
    //如果via信息含有wap则一定是移动设备,部分服务商会屏蔽该信息
	if (isset($_SERVER['HTTP_VIA']))  {
	     return stristr($_SERVER['HTTP_VIA'], 'wap') ? true : false;//找不到为flase,否则为true
    }
    //判断手机发送的客户端标志,兼容性有待提高
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
	     $clientkeywords = [
             'nokia', 'sony', 'ericsson', 'mot', 'huawei', 'xiaomi', 'oppo', 'vivo', 'honor', 'yijia', 'samsung', 'htc', 'sgh', 'lg', 'sharp', 'sie-', 'philips', 'panasonic', 'alcatel', 'lenovo',
             'iphone', 'ipod', 'blackberry', 'meizu', 'android', 'netfront', 'symbian', 'ucweb', 'windowsce', 'palm', 'operamini', 'operamobi', 'openwave', 'nexusone', 'cldc', 'midp', 'wap', 'mobile'
         ];
	    //从HTTP_USER_AGENT中查找手机浏览器的关键字
		if (preg_match("/(" . implode('|', $clientkeywords) . ")/i", strtolower($_SERVER['HTTP_USER_AGENT']))) {
        	return true;
        }
    }
	 //协议法，因为有可能不准确，放到最后判断
    if (isset($_SERVER['HTTP_ACCEPT'])) {
        // 如果只支持wml并且不支持html那一定是移动设备
        // 如果支持wml和html但是wml在html之前则是移动设备
        if ((strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') !== false) && (strpos($_SERVER['HTTP_ACCEPT'], 'text/html') === false || (strpos($_SERVER['HTTP_ACCEPT'], 'vnd.wap.wml') < strpos($_SERVER['HTTP_ACCEPT'], 'text/html')))) {
                return true;
        }
    }
    return false;
}

//将需要的二维数组中一维数组返回回去(某个字段最大的还是最小的)
function oneArray($arr,$field,$max)//$arr数组，$filed字段，$max大小（$max为大，$min为小）
{
	$temp = [];
	foreach ($arr as $k =>$v){
		$temp[] = $v[$field];
	}
	switch ($max) {
		case 'max':
			foreach ($arr as $key => $val){
				if($arr[$key][$field] == max($temp)){
					return $arr[$key];
				}
			}
		break;
		default:
			foreach ($arr as $key => $val){
				if($arr[$key][$field] == min($temp)){
					return $arr[$key];
				}
			}
		break;
	}
}

/**
 *  截取字符串，包含汉字
 *  @param varchar $str 需要截取的字符串
 *  @param intval  $num 截取的字符串长度
 *  @return arr 转换后的字符串
 */
function diySubStr($str, $num, $flag = false, $unhtml = true,  $eli = '...')
{
    if ($unhtml) {
        $str = str_replace("&nbsp;", '', $str);
        $str = strip_tags($str);
    }
    if ($str == '' || $num <= 0) {
        return $str;
    }
    $strlen = mb_strlen($str, 'utf-8');
    $new_str ='';
    $new_str .= mb_substr($str, 0, $num, 'utf-8');
    if ($num < $strlen && $flag) {
        $new_str .= $eli;
    }
    return $new_str;
}

//删除根据目录删除子文件
function dir_del($dirpath)
{
    $dh=opendir($dirpath);
    while (($file=readdir($dh))!==false) {
        if($file!="." && $file!="..") {
            $fullpath=$dirpath."/".$file;
            if(!is_dir($fullpath)) {
                unlink($fullpath);
            } else {
                dir_del($fullpath);
                @rmdir($fullpath);
            }
        }
    }
    closedir($dh);
    $isEmpty = true;
    $dh=opendir($dirpath);
    while (($file=readdir($dh))!== false) {
        if($file!="." && $file!="..") {
            $isEmpty = false;
            break;
        }
    }
    return $isEmpty;
}
