<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\controller;

use think\Loader;
use think\Db;

class Show extends Common
{
    // 详情页渲染
    public function index($id)
    {
        $ids = $_SERVER["QUERY_STRING"];
        $arr = explode( '/',$ids);
        $id = $arr[count($arr)-1];

        $content_model  = Loader::model('Content');
        $category_model = Loader::model('Category');
        
        $contents  = $content_model->getContentById($id);   // 内容详情
        $categorys = $category_model->getOnecategory($contents['cid']); // 内容所在分类
        $top       = $category_model->getTopCategory($categorys['id']);   // 内容顶级分类

        if (!$categorys['tpl_detail']) {
            $this->error('模板未选择');
        }

        $this->assign('content_id', $id);
        $this->assign('category_id', $categorys['id']);
        $this->assign('top_id', $top['id']);
        
        $content_model->addContentBrowse($id);  // 增加浏览量

        return $this->fetch(WEB_PATH.'/'.$categorys['tpl_detail']);
    }

    // 提交表单
    public function submit()
    {
        $data = request()->param();
        if (!isset($data['id'])){
            $this->error('缺少参数');
        }
 
        $forms  = Loader::model('DIyForm')->getForm($data['id']);   // 表单对应的数据表名称
        $fields = Loader::model('Field')->getField($data['id'], 2); // 表单字段信息
        if (isset($data['code']) && !captcha_check($data['code'])) {
            $this->error('验证码错误');
        }
        $arr = [];
        foreach ($fields as $k => $v) {
            foreach ($data as $key => $val) {
                if ($key == $fields[$k]['field']) {
                    array_push($arr,[$fields[$k]['field']=>$data[$key]]);
                }
            }
        }
        $array = [];
        foreach ($arr as $k => $v) {
            foreach ($v as $key => $val) {
                $array[$key] = $val;
            }
        }
        $res = Db::name('form_'.$forms['table_name'])->insert($array);

        // 添加邮箱提醒
        if ($forms['is_send_email'] == 1) {
            $to_email = $forms['email'];
            $subject  = $forms['email_title'];
            $content  = $forms['email_content'];
            if (preg_match("/[a-zA-Z0-9_]+@[0-9a-z]+(\\.[a-z]+)+$/", $to_email) && $subject!='' && $content!='') {
                self::sendEmail($to_email, $subject, $content);
            }
        }

        if ($res){
            $this->success('提交表单成功');
        }else{
            $this->error('提交表单失败');
        }
    }

    // 发送邮件
    function sendEmail($to_email, $subject, $content)
    {
        Vendor('phpmailer.phpmailer');
        $mail = new \phpmailer\PHPMailer();     //实例化

        $mail->IsSMTP(); // 启用SMTP
        $mail->Host = 'smtp.qq.com'; //SMTP服务器 以126邮箱为例子
        $mail->Port = 465;  //邮件发送端口
        $mail->SMTPAuth = true;  //启用SMTP认证
        $mail->SMTPSecure = "ssl";   // 设置安全验证方式为ssl

        $mail->CharSet = "UTF-8"; //字符集
        $mail->Encoding = "base64"; //编码方式

        $mail->Username = Loader::model('Config')->getConfigByTag('email_name');  //你的邮箱
        $mail->Password = Loader::model('Config')->getConfigByTag('email_pass');  //你的授权吗
        $mail->Subject  = $subject; //邮件标题

        $mail->From = Loader::model('Config')->getConfigByTag('email_name');  //发件人地址（也就是你的邮箱）
        $mail->FromName = '提示信息';  //发件人姓名

        $mail->AddAddress($to_email, $to_email);    //添加收件人（地址，昵称）
        $mail->IsHTML(true);    //支持html格式内容
        $mail->Body = $content; //邮件主体内容

        //发送成功就删除
        if ($mail->Send()) {
            
        }else{
            echo "Mailer Error: ".$mail->ErrorInfo;// 输出错误信息
        }
    }
}