<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\model;

use think\Model;

class Category extends Model
{
    protected $name = 'category';

    // 获取栏目的url
    public function getCategoryUrl($data)
    {
        if ($data['jump_url'] == '') {
            if ($data['pid']==0 && $data['tpl_cover']=='' && $data['tpl_list']=='') {
                $child_url = $this->where('pid', $data['id'])->order('rank asc, id asc')->where('status', 1)->value('tag');
                if (isset($child_url) && $child_url!='') {
                    $data['url'] = config('sys.site_url').'/'.$child_url;
                } else {
                    $data['url'] = config('sys.site_url').'/'.$data['tag'];
                }
            } else {
                $data['url'] = config('sys.site_url').'/'.$data['tag'];
            }
        } else {
            $data['url'] = $data['jump_url'];
        }

        return $data['url'];
    }

    // 获取单个栏目信息
    public function getOnecategory($id)
    {
        $res = $this->where('id', $id)->find();
        if ($res) {
            $res = $res->toArray();
            $res['url'] = self::getCategoryUrl($res);
        } else {
            $res = [];
        }

        return $res;
    }

    // 获取上一级栏目信息
    public function getFatherCategory($id)
    {
        $pid = $this->where('id', $id)->value('pid');
        if (isset($pid) && $pid!=0) {
            $res = $this->where('id', $pid)->find();
            if ($res) {
                $res = $res->toArray();
                $res['url'] = self::getCategoryUrl($res);
            } else {
                $res = [];
            }
        } else {
            $res = [];
        }
        
        return $res;
    }

    // 获取上级所有栏目信息，可用户面包屑导航 by WQ , list 为栏目数组，id 为当前分类id，hs_self 包含自己，默认false不包含
    public function getAllFatherCategory($list, $id, $hs_self=false)
    {
        $arr = [];
        $pid = $this->where('id', $id)->value('pid');
        foreach ($list as $v) {
            if ($v['id'] == $pid) {
                $arr[] = $v;
                $arr = array_merge($this->getAllFatherCategory($list, $v['id']),  $arr);
            }
        }

        if ($hs_self == true) {
            $arr[] = $this->getOnecategory($id);
        }
        return $arr;
    }

    // 获取顶级栏目信息 by WQ
    public function getTopCategory($id)
    {
        $res = $this->where('id', $id)->find();
        if ($res) {
            $res = $res->toArray();
            $res['url'] = self::getCategoryUrl($res);
            if ($res['pid'] != 0) {
                $res = $this->getTopCategory(($res['pid']));
            }
        }
        return $res;
    }

    // 获取同级栏目信息 by WQ
    public function getSameCategory($id)
    {
        $pid = $this->where('id', $id)->value('pid');
        if (isset($pid)) {
            $res = $this->where('pid', $pid)->where('status', 1)->select();
            $res = isset($res) ? $res->toArray() : [] ;
            foreach ($res as $k => $v) {
                $res[$k]['url'] = self::getCategoryUrl($v);
            }
        } else {
            $res = [];
        }
        return $res;
    }

    // 获取下级栏目信息 by WQ
    public function getChildCategory($id=0)
    {
        $arr = [];
        $res = $this->where('pid', $id)->where('status', 1)->select();
        if ($res) {
            $res = $res->toArray();
            foreach ($res as $k => $v) {
                $v['url'] = self::getCategoryUrl($v);
                $v['child'] = $this->getChildCategory($v['id']);
                $arr[] = $v;
            }
        }
        return $arr;
    }

    // 获取所有栏目分类
    public function lists($where=[])
    {
        if (!cache('list')) {
            $list = $this->where('status', 1)->where($where)->order('rank asc, id asc')->select();
            if ($list) {
                $list = $list->toArray();
                foreach ($list as $key => $val) {
                    $list[$key]['url'] = self::getCategoryUrl($val);
                }
            } else {
                $list = [];
            }
        } else {
            $list = cache('list');
        }
        return $list;
    }
    
    // 将所有分类根据父子关系分级展示
    public function getParentsRelation($list, $name = 'child', $pid = 0)
    {
        $arr = [];
        $index = 1;
        foreach ($list as $k => $v) {
            if ($v['pid'] == $pid) {
                $v[$name] = $this->getParentsRelation($list, $name, $v['id']);
                $index++;
                $arr[] = $v;
            }
        }
        return $arr;
    }

    // 获取当前分类的所有子类id   list：分类数组, id：父级id
    public function getAllSonIds($list, $id = 0)
    {
        $arr = [];
        foreach ($list as $v) {
            if ($v['pid'] == $id) {
                $arr[] = $v['id'];
                $arr = array_merge($arr, $this->getAllSonIds($list, $v['id']));
            }
        }
        return $arr;
    }
}