<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\taglib;

use think\template\TagLib;
use think\Loader;

class Jidu  extends TagLib
{
    protected $tags = [
        'config'	=> ['attr' => 'name,text_flag',                                          'close' => 0],     // 读取配置信息
        'nav'		=> ['attr' => 'cat',                                                     'close' => 1],     // 导航
        'banner'	=> ['attr' => 'type',                                                    'close' => 1],     // banner
        'cats'		=> ['attr' => 'cid,type',                                                'close' => 1],     // 获取栏目信息
        'content'   => ['attr' => 'cid,title_len,keywords,tag,pagesize,recommend,is_all',    'close' => 1],     // 内容列表
        'detail'	=> ['attr' => 'id',                                                      'close' => 1],     // 内容详情
        'link'		=> ['attr' => '',                                                        'close' => 1],     // 友情链接
        'block'		=> ['attr' => 'name, class',                                             'close' => 0],     // 自定义块
        'position'	=> ['attr' => 'cid, separator',                                          'close' => 1],     // 面包屑导航
        'form' 		=> ['attr' => 'id',                                                      'close' => 1],     // 表单标签
    ];

    // 读取配置信息
    public function tagConfig($attr)
    {
        $name	   = isset($attr['name']) ? trim($attr['name']) : '';
        $text_flag = isset($attr['text_flag']) && $attr['text_flag']==0 ? 0 : 1;    // 1文字展示，0图片展示

        // 构造标签数据
        $config_model = Loader::model('Config');
        $res = $config_model->getConfigByTag($name);
        $info = $res ? ($text_flag==1 ? $res : '<img src=\''.$res.'\'>') : '';
        return $info;
    }

    // 导航标签 - 可无限极分类，子分类名称为 child
    public function tagNav($attr, $content)
    {
        $cat = isset($attr['cat']) ? trim($attr['cat']) : '';     // header 主导航， footer 尾导航， all 全部

        if ($cat == 'header') {
            $nav = '2,4';
        } else if ($cat == 'footer') {
            $nav = '3,4';
        } else {
            $nav = '2,3,4';
        }

        $str = "<?php 
            \$category_model = think\Loader::model('Category');
            \$where = ['nav'=>['in', '$nav']];
            \$list = \$category_model->lists(\$where);
            \$list = \$category_model->getParentsRelation(\$list);
            foreach (\$list as \$key => \$nav) { ?>";
        $str .= $content;
        $str .='<?php } ?>';

        return $str;
    }

    // banner 标签
    public function tagBanner($attr, $content)
    {
        $cat = isset($attr['type']) && trim($attr['type'])=='wap' ? 2 : 1;    // 1=>pc, 2=>wap, 默认PC

        $str = "<?php
            \$banner_model = think\Loader::model('Banner');
            \$list = \$banner_model->lists(['type'=>$cat]);
            foreach (\$list as \$key => \$banner) {?>";
        $str .= $content;
        $str .= '<?php }?>';

        return $str;
    }

    // 栏目标签
    public function tagCats($attr, $content)
    {
        if (isset($attr['cid'])) {
            $cid  = $attr['cid'];   // 栏目id，注意，这里如果是传变量进来的话，就是是个变量名，而不是具体的值，只有传具体值进来的时候，才可以获取到值
        } else {
            exception('cats标签缺少必要参数cid', 1000);
        }
        $type = isset($attr['type']) && $attr['type']!='' ? trim($attr['type']) : 'self'; // self自己,father上级,top顶级,allfather上级所有,same同级,myson下级, topson

        $str = <<<str
        <?php
            \$cid = '$cid';
            \$type = '$type';

            if (\$cid != -1 && !(\$cid>0)) {    // 传变量进来的话，直接给变量赋值
                \$cid = $cid;
            }

            \$category_model = think\Loader::model('Category');

            \$list = [];
            if (\$type == 'self') {     // 获取分类自己的信息
                \$list[] = \$category_model->getOnecategory(\$cid);
            } 
            else if (\$type == 'father') {  // 获取分类父级的信息
                \$list[] = \$category_model->getFatherCategory(\$cid);
            }
            else if (\$type == 'top') {     // 获取顶级栏目信息
                \$list[] = \$category_model->getTopCategory(\$cid);
            }
            else if (\$type == 'allfather') {   // 获取上级所有栏目信息
                \$all = db('category')->field('desc,content', true)->where('status', 1)->select();
                \$list = \$category_model->getAllFatherCategory(\$all, \$cid);
            }
            else if (\$type == 'same') {    // 获取同级分类
                \$list = \$category_model->getSameCategory(\$cid);
            }
            else if (\$type == 'myson') {   // 获取下级分类
                \$list = \$category_model->getChildCategory(\$cid);
            } 
            else if (\$type == 'topson') {  // 获取顶级分类下面的所有栏目分类
                \$top  = \$category_model->getTopCategory(\$cid);
                \$list = \$category_model->getChildCategory(\$top['id']);
            }
            else {
                \$list[] = \$category_model->getOnecategory(\$cid);
            }
            
            \$index = 1;
            foreach(\$list as \$key => \$cats) {
            	\$cats['index'] = \$index;
            	\$index++;
        ?>
str;
        $str .= $content;
        $str .='<?php };?>';
        return $str;
    }

    // 内容列表标签
    public function tagContent($attr, $content)
    {
        if (isset($attr['cid'])) {
            $cid  = $attr['cid'];   // 栏目id，注意，这里如果是传变量进来的话，就是是个变量名，而不是具体的值，只有传具体值进来的时候，才可以获取到值
        } else {
            exception('content标签缺少必要参数cid', 1000);
        }
        $is_all     = isset($attr['is_all']) && $attr['is_all']==1 ? 1 : 0;                     // 默认只读取本级分类下面的文章
        $keywords   = isset($attr['keywords']) ? trim($attr['keywords']) : '';                  // 默认不进行关键字查询
        $tag        = isset($attr['tag']) ? trim($attr['tag']) : '';                            // 默认不进行标签查询
        $recommend  = isset($attr['recommend']) && $attr['recommend']==1 ? 1 : 0;               // 默认不读取推荐文章
        $pagesize   = isset($attr['pagesize']) && $attr['pagesize']>0 ? $attr['pagesize'] : 15; // 默认分页长度为5
        $title_len  = isset($attr['title_len']) && $attr['title_len']>0 ? $attr['title_len'] : 0;   // 默认不截取标题

        $str = <<<str
        <?php
            \$cid       = $cid;
            \$is_all    = $is_all;
            \$keywords  = '$keywords';
            \$tag       = '$tag';
            \$recommend = $recommend;
            \$pagesize  = $pagesize;
            \$title_len = $title_len;
            \$query     = input();  // 分页带参

            \$where = [];
            if (\$cid > 0) {
                if (\$is_all == 1) {
                    \$category_model = think\Loader::model('Category');
                    \$list = \$category_model->lists();
                    \$ids = \$category_model->getAllSonIds(\$list, \$cid);
                    \$ids[] = intval(\$cid);
                    \$where['cid'] = ['in', \$ids];
                } else {
                    \$where['cid'] = \$cid;
                }
            }
            \$where['title'] = \$keywords != '' ? ['like', '%'.\$keywords.'%'] : ['like', '%'.input('keywords').'%'];
            \$where['tag']   = \$tag != '' ? ['like', '%'.\$tag.'%'] : ['like', '%'.input('tag').'%'];
            if (\$recommend == 1) {
                \$where['recommend'] = 1;
            }

            \$table_name = '';
            if (\$cid > 0) {
                \$mid = db('category')->where('id', \$cid)->value('mid');
                \$table_name = db('auth_model')->where('id', \$mid)->value('table_name');
            }

            if (\$table_name != '') {
                \$table = config('database.prefix').'diy_'.\$table_name;
                \$res = db('content')->alias('a')->join(\$table.' b', 'a.the_id=b.id', 'left')->where(\$where)->field('b.*, a.*, b.id third_id')->order('a.rank asc, a.id desc')->paginate(\$pagesize, false, ['query'=>\$query]);
            } else {
                \$res = db('content')->where(\$where)->order('rank asc, id desc')->paginate(\$pagesize, false, ['query'=>\$query]);
            }

            \$page = \$res->render();
            \$res  = \$res->toArray();
            \$res  = \$res['data'];

            \$index = 1;
            \$content_model  = think\Loader::model('Content');
            \$category_model = think\Loader::model('Category');
            foreach (\$res as \$k => \$content) {
                \$content['title'] = \$title_len>0 ? diySubStr(\$content['title'], \$title_len) : \$content['title'];
                \$content['url']   = \$content_model->getContentUrl(\$content['id']);
                \$content['cat_name'] = \$category_model->where('id', \$content['cid'])->value('title');
                \$content['index'] = \$index;
                \$index++;
        ?>
str;
        $str .= $content;
        $str .= '<?php } ?>';
        return $str;
    }

    // 内容详情页标签
    public function tagDetail($attr, $content)
    {
        if (isset($attr['id'])) {
            $id  = $attr['id'];   // 内容id，注意，这里如果是传变量进来的话，就是是个变量名，而不是具体的值，只有传具体值进来的时候，才可以获取到值
        } else {
            exception('detail标签缺少必要参数id', 1000);
        }

        $str = <<<str
        <?php
            // 构造标签数据
            \$detail = [];
            \$id = '$id';

            if (\$id != -1 && !(\$id>0)) {    // 传变量进来的话，直接给变量赋值
                \$id = $id;
            }

            if (\$id > 0) {
                \$content_model = think\Loader::model('Content');
                \$category_model = think\Loader::model('Category');

                \$detail = \$content_model->getOneContent(['id'=>\$id]);
                if (\$detail) {
                    // 通过模型id获取对应的数据表，读取自定义表中的数据
                    \$table_name = '';
                    if (\$detail['mid'] > 0) {
                        \$table_name = db('auth_model')->where('id', \$detail['mid'])->value('table_name');
                        if (\$table_name) {
                            \$table  = config('database.prefix').'diy_'.\$table_name;
                            \$detail = db('content')->alias('a')->join(\$table.' b', 'a.the_id=b.id')->field('b.*, a.*, b.id third_id')->where('a.id', \$id)->find();
                        }
                    }

                    \$prev = \$content_model->getOneContent(['cid'=>\$detail['cid'], 'id'=>['<', \$id]], 'rank desc');
                    if (\$prev) {
                        \$detail['prev_title'] = \$prev['title'];
                        \$detail['prev_url']   = \$prev['url'];
                    } else {
                        \$detail['prev_title'] = '没有上一篇了';
                        \$detail['prev_url']   = '';
                    }

                    \$next = \$content_model->getOneContent(['cid'=>\$detail['cid'], 'id'=>['>', \$id]], 'rank asc');
                    if (\$next) {
                        \$detail['next_title'] = \$next['title'];
                        \$detail['next_url']   = \$next['url'];
                    } else {
                        \$detail['next_title'] = '没有下一篇了';
                        \$detail['next_url']   = '';
                    }

                    // 获取当前分类信息
                    \$cat_name = \$category_model->where('id', \$detail['cid'])->value('title');
                    \$detail['cat_name'] = \$cat_name ? \$cat_name : '';

                    // 获取统计产品信息
                    \$friend = db('content')->where(['cid'=>\$detail['cid']])->where(['id'=>['neq',\$detail['id']]])->order('rank desc')->limit(8)->select();
                    \$detail['friend'] = \$friend;

                    // 获取上级所有分类 : 弃用，直接用cats标签读取即可
                    \$father_ = \$father = [];
                    \$all_cat = \$category_model->lists();
                    if (\$all_cat) {
                        \$father = \$category_model->getAllFatherCategory(\$all_cat, \$detail['cid']);
                    }

                    if (\$father) {
                        foreach(\$father as \$k => \$v) {
                            \$father_[] = [
                                'id'	=> \$v['id'],
                                'pid'	=> \$v['pid'],
                                'title'	=> \$v['title'],
                                'url'	=> \$v['url']
                            ];
                        }
                    }
                    \$detail['father'] = \$father_;
                }
            }
        ?>
str;
        $str .= $content;
        return $str;
    }

    // 友情链接标签
    public function tagLink($attr, $content)
    {
        $str = "<?php
            \$link_model = think\Loader::model('Link');
            \$list = \$link_model->lists();
            foreach (\$list as \$key => \$link) { ?>";
        $str .= $content;
        $str .= '<?php }?>';
        return $str;
    }

    // 自定义块
    public function tagBlock($attr)
    {
        // block 标签属性 ： name, img_flag(是否图片展示)
        $name   = isset($attr['name']) ? $attr['name'] : '';
        $class  = empty($attr['class']) ? '' : $attr['class'];

        $block_model = Loader::model('Block');
        $res = $block_model->getSingBlock($name, $class);

        return $res['content'];
    }

    // 面包屑导航    position 标签属性： cid 栏目分类， separator 分割线
    public function tagPosition($attr, $content)
    {   
        if (isset($attr['cid'])) {
            $cid  = $attr['cid'];   // 内容id，注意，这里如果是传变量进来的话，就是是个变量名，而不是具体的值，只有传具体值进来的时候，才可以获取到值
        } else {
            exception('position标签缺少必要参数cid', 1000);
        }
        $separator = empty($attr['separator']) ? '&gt;&gt;' : $attr['separator'];

        $str = "
        <?php
            \$cid = '$cid';
            \$separator = '$separator';
            \$list = [];
            \$position = '';

            if (\$cid != -1 && !(\$cid>0)) {    // 传变量进来的话，直接给变量赋值
               \$cid = $cid;
            }

            if (\$cid != -1) {
                \$category_model = think\Loader::model('Category');
                \$all_cat = \$category_model->lists();

                if (\$all_cat) {
                    \$father = \$category_model->getAllFatherCategory(\$all_cat, \$cid, true);
                    if (\$father) {
                        \$position = '当前位置： <a href='.config('sys.site_url').'>首页</a> ';
                        foreach (\$father as \$val) {
                            \$position .= \$separator.'<a href='.\$val['url'].'>'.\$val['title'].'</a>';
                        }
                    }
                }
            }?>";
        $str .= $content;
        return $str;
    }

    // 表单
    public function tagForm($attr, $content)
    {
        // form 标签属性： id 表单id
        $id = empty($attr['id']) ? -1 : trim($attr['id']);

        $str = "
        <?php
    		\$form  = [];
    		\$table = [];
    		\$list  = [];
    		\$id = '$id';
    		if (\$id != -1) {
                \$field_model = think\Loader::model('Field');
                \$form_model  = think\Loader::model('DIyForm');
    			\$form = \$form_model->getForm(\$id);
                \$list = \$field_model->getField(\$id, 2);
                \$form['table'] = \$form;
                \$form['field'] = \$list;
    		}
        ?>";
        $str .= $content;

        return $str;
    }
}